var timerHide = null;
var curX = 0;
var curY = 0;

function FS_GetString(nStringId)
{
	var litmusObj = null;
	try {
		litmusObj = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
	}catch (e){
		//dump("error " + e + "\n");
	}
	
	//make sure Litmus is always visible
	return litmusObj.excCommand(1103,nStringId);
	//document.getElementById("domainText").value=window.arguments[0];
}

function updateMouseXY(e)
{
	curX = e.pageX;
	curY = e.pageY;
	var nodeBubble = document.getElementById("btc");
	if(!nodeBubble || nodeBubble.show == false) return;
	var minX = nodeBubble.offsetLeft - 5;
	var maxX = nodeBubble.offsetLeft + nodeBubble.offsetWidth + 5;
	var minY = nodeBubble.offsetTop - 5;
	var maxY = nodeBubble.offsetTop + nodeBubble.offsetHeight + 5;
	if(curX < minX || curX > maxX)
	{
		FS_RealHideBubble();
	}
	if(curY < minY || curY > maxY)
	{
		FS_RealHideBubble();
	}
}

document.onmousemove = updateMouseXY;

function FS_moveBubble(event)
{
	if(timerHide)
		clearTimeout(timerHide);
	var posx=0,posy=0;
	if(event==null) e=window.event;
	posx=event.pageX; posy=event.pageY;
	//dump("eval " + posx + " with " + window.pageXOffset + "\n");
	if((posy - 290) > window.pageYOffset)
	{
		posy-=290;
	}
	if((posx - 342) > window.pageXOffset)
	{
		posx-=342;
	}
	document.getElementById("btc").style.top=(posy+2)+"px";
	document.getElementById("btc").style.left=(posx+2)+"px";
}

function FS_createElement(tag,class)
{
	var nodeRet = document.createElement(tag);
	nodeRet.setAttribute("class",class);
	nodeRet.setAttribute("style","display:block; z-index: 4242;");
	return nodeRet;
}

function FS_setOpacity(elem)
{
	elem.style.filter="alpha(opacity:95)";
	elem.style.KHTMLOpacity="0.95";
	elem.style.MozOpacity="0.95";
	elem.style.opacity="0.95";
}

function FS_GetRate(szResult)
{
	var arParam = szResult.split("*");
	return "test";
}

function FS_GetDetailDesc(szResult)
{
	var arParam = szResult.split("*");
	if(arParam[3])
		return preEmDetail[arParam[3]];
	else
		return preEmDetail[0];
}

function FS_showBubble(event,node)
{
	clearTimeout(timerHide);
	FS_RealHideBubble();
	if(!document.getElementById("btc").firstChild)
	{
		//alert(FS_GetRate(node.getAttribute("fsmarker")));
		var szSite = (node.getAttribute("fslinker").split("://")[1]?node.getAttribute("fslinker").split("/")[2].split("?")[0]:node.getAttribute("fslinker").split("/")[0].split("?")[0]);
		if(szSite.length>29) szSite = szSite.substring(0,27) + "...";
		document.getElementById("btc").innerHTML =
			'<table class="tipBG" style="text-align: left; width: 342px; height: 290px; table-layout:fixed;" border="0" cellpadding="0" cellspacing="0"">' +
			'<tbody>' +
			'<col width="10px"/><col/><col/><col width="10px"/>' +
			'<tr style="height: 40px;">' +
				'<td rowspan="11" style="width: 10px;">&nbsp;</td><td colspan="2" style="text-align:right; color: red; width: 220px;" onclick="FS_RealHideBubble();"><img src="chrome://litmus-ff/skin/small/close.gif"/></td><td rowspan="11" style="width: 10px;">&nbsp;</td>' +
			'</tr>' +
			'<tr>' + //image main title
				'<td colspan="2">' +
					'<span class="tipMain"><img style="width: 18px; height: 18px;" src="' + node.src.replace(/(small)/gi,"pop") + '"/>' +
				    FS_GetRate(node.getAttribute("fsmarker")) + '</span>' +
				'</td>' +
			'</tr>' +
			'<tr>' +
				'<td style="height: 20px;" colspan="2"></td>' +
			'</tr>' +
			'<tr>' + //explain why
				'<td colspan="2">' +
			    	'<span class="tipDesc">' +
			      	FS_GetDetailDesc(node.getAttribute("fsmarker")) +
			      	'</span>' +
				'</td>' +
			'</tr>' +
			'<tr>' +
				'<td style="height: 20px;" colspan="2"></td>' +
			'</tr>' +
			'<tr>' +
				'<td colspan="2">' +
			    '<span class="tipDetail">' +
			    'Details' +
			    '</span>' +
				'</td>' +
			'</tr>' +
			'<tr>' +
				'<td class="descLeft tipDesc">Address:</td>' +
				'<td style="overflow:hide;"><span class="tipDesc">' + szSite + '</span></td>' +
			'</tr>' +
			'<tr>' +
				'<td class="descLeft tipDesc">Categorized:</td>' +
				'<td><span class="tipDesc">' + node.getAttribute("fsmarker").split("*")[1] +
				'</span></td>' +
			'</tr>' +
			'<tr>' +
				'<td style="height: 20px;" colspan="2"></td>' +
			'</tr>' +
			    '<td colspan="2">' +
			    '<span class="tipDetail">' +
			    '<a class="tipDetail" onclick="document.location.href=\'http://10.70.0.25:8080/nrs-lookup/feedback\';">Tell F-Secure ...</a>' +
			    '</span>' +
				'</td>' +
			'</tr>' +
			'<tr>' +
				'<td style="height: 40px;" colspan="2"></td>' +
			'</tr>' +
		'</tbody>' +
		'</table>';
//		FS_setOpacity(document.getElementById("btc").firstChild);
		document.getElementById("btc").show = true;
	}
	//move to position we want
	FS_moveBubble(event);
}


function FS_RealHideBubble()
{
	clearTimeout(timerHide);
	timerHide = null;
	var nodeBubble=document.getElementById("btc");
	if(nodeBubble.childNodes.length>0) nodeBubble.removeChild(nodeBubble.firstChild);
	document.getElementById("btc").show = false;
}

function FS_hideBubble()
{
	var nodeBubble=document.getElementById("btc");
//	dump("calculating ......");
//	dump(nodeBubble.offsetTop + " " + nodeBubble.offsetHeight + " " + (curX) + "\n");
//	dump("evaluating..... " + (curY < nodeBubble.offsetTop+2) + " or " + (curY > (nodeBubble.offsetTop + nodeBubble.offsetHeight - 2)) + "\n");
	if((curX < nodeBubble.offsetLeft+2) || (curX > (nodeBubble.offsetLeft + nodeBubble.offsetWidth - 2)))
	{
		timerHide = setTimeout("FS_RealHideBubble()",200);
	}
	if((curY < nodeBubble.offsetTop+2) || (curY > (nodeBubble.offsetTop + nodeBubble.offsetHeight - 2)))
	{
		timerHide = setTimeout("FS_RealHideBubble()",200);
	}
}

//modiy current doc script
function FS_addBubble(docTarget)
{
return;
	if(docTarget.getElementById("btc")) return;
	var nodeBubble = docTarget.createElement("span");
	nodeBubble.setAttribute("id", "btc");
	nodeBubble.setAttribute("style", "position:absolute; z-index: 4242;");
	docTarget.getElementsByTagName("body")[0].appendChild(nodeBubble);
	var nodeScript = docTarget.createElement("script");
	nodeScript.setAttribute("src", "chrome://litmus-ff/content/bubble.js");
	nodeScript.setAttribute("type", "text/javascript");
	docTarget.getElementsByTagName("head")[0].appendChild(nodeScript);
	var nodeStyle = docTarget.createElement("link");
	nodeStyle.setAttribute("type","text/css");
	nodeStyle.setAttribute("media","screen");
	nodeStyle.setAttribute("rel","stylesheet");
	nodeStyle.setAttribute("href","chrome://litmus-ff/skin/popbuble.css");
	docTarget.getElementsByTagName("head")[0].appendChild(nodeStyle);
	///
	var nodeValue = docTarget.createElement("script");
	nodeValue.setAttribute("type", "text/javascript");
	nodeValue.innerHTML = "var preEmType = [\"" + FS_GetString(100) +"\",\"" + FS_GetString(101) +"\",\"" + FS_GetString(102) +"\",\"" + FS_GetString(103) +"\",\"" + FS_GetString(104) +"\",\"" + FS_GetString(105) + "\"];";
	docTarget.getElementsByTagName("head")[0].appendChild(nodeValue);
	var nodeValue2 = docTarget.createElement("script");
	nodeValue2.setAttribute("type", "text/javascript");
	nodeValue2.innerHTML = "var preEmDetail = [\"" + FS_GetString(200) +"\",\"" + FS_GetString(201) +"\",\"" + FS_GetString(202) +"\",\"" + FS_GetString(203) +"\",\"" + FS_GetString(204) +"\",\"" + FS_GetString(205) + "\"];";
	docTarget.getElementsByTagName("head")[0].appendChild(nodeValue2);
}

/******************************************************************************/
function XX_ShowToolbar()
{
return;
	if(XX_GetUserPref() == "3") return;
	document.popupNode = document.getElementById("litmus-ff-button");
	var elem = document.getElementById("litmus-ff-button");
	var popElement = document.getElementById("litmus-ff-popinfo");
	var szResult = document.getElementById('litmus-ff-tooltip-text').getAttribute("value");
	if( szResult == "") return;
	
	var arParam = szResult.split("*");
	var popElement = document.getElementById("xxImg");
	popElement.setAttribute("src",arParam[0].replace(/(small)/gi,"pop"));
	popElement = document.getElementById("xxRate");
	if(arParam[3])
		popElement.value = FS_GetString(10+arParam[3]);
	else
		popElement.value = FS_GetString(10+0);
	popElement = document.getElementById("xxDetail");
	if(arParam[3])
		popElement.firstChild.nodeValue = FS_GetString(20+arParam[3]);
	else
		popElement.firstChild.nodeValue = FS_GetString(20+0);

	//dump("szResult === .... *" + popElement.innerHTML + "*....\n");
	popElement = document.getElementById("xxSite");
	var szAddress = document.getElementById('litmus-ff-tooltip-docloc').getAttribute("value")//window.content.document.location.href;
	var szSite = szAddress.split("://")[1]?szAddress.split("/")[2].split("?")[0]:szAddress.split("/")[0].split("?")[0];
	if(szSite.length>29)
		szSite = szSite.substring(0,27) + "...";
	popElement.value = szSite;//szAddress.split("://")[1]?szAddress.split("/")[2].split("?")[0]:szAddress.split("/")[0].split("?")[0];
	popElement = document.getElementById("xxCat");
	popElement.value = arParam[1];
	document.getElementById("litmus-ff-popinfo").showPopup(elem,elem.boxObject.x,elem.boxObject.y + elem.boxObject.height,"popup");
}

function XX_HideToolbar()
{
	document.getElementById("litmus-ff-popinfo").hidePopup();
}
