var FS_MailRegEx = [null,/https?:\/\/mail\.(google)\.com/i,/mail\.(yahoo)\.com/i];
var FS_OtherRegEx = [null,/(https?:\/\/)*(\.wiki)*(\.org)/i];

var g_OnProgressResult = null;
var g_OnProgressRequest = null;
var g_CurrentMode = "";
var g_arrBlockPageLinks = null;
var g_BlockPagePosition = 0;
var g_BlockPage = null; // Rex 10/03/09 - Hold block page document
var g_BlockURL = null;
var gWhiteListAccess = null;
var g_PreviousBlockUrl = ""; // leekea - hold previous block page url for 2 seconds

// timeout id
var timerBPOnOffId;
var timerToolbarRefreshId;

//Put up all listener we need
window.addEventListener("load", XX_onPluginLoad, false);
window.addEventListener("unload", XX_onPluginUnload, false);

//Mozilla version; default version is Firefox 3.0
var g_MozillaVersion = 3; 

// Fspc
var g_OnFspcLoaded = false;

Math.randomMax = function(maxVal,asFloat){
    var val = Math.random()*maxVal;
    return asFloat?val:Math.round(val)>0?Math.round(val):Math.round(val)+1;
}

function XX_loadURL(url)
{
    if (url=="") return true;
    window.content.document.location.href=url;
    return true;
}

function XX_GetBlockUrlEx()
{
    try {
        var localInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        if(localInterface){
            var strBlockPage = localInterface.excCommand(1116,0);
            //return strBlockPage;
            return unescape(strBlockPage);
        }
    }catch (e){
    //dump(e);
    }
//return "http://localhost:6789/block.html?url=" + window.content.document.location.href;
}

// leekea - notify backend to send alert to policy manager
// bUserContinue - true indicate user continue to a blocked page, false indicate page is blocked
function NotifyPolicyManager(url, bUserContinue)
{
    if (!bUserContinue && g_PreviousBlockUrl == url){
        return;
    } else {
        g_PreviousBlockUrl = url;
        setTimeout(function(){g_PreviousBlockUrl = "";}, 2000);
    }
    
    var pluginInterface = null;
    try {
        pluginInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
    }catch (e){
    //dump(e);
    }
    if (!pluginInterface){
        return;
    }
    var szResult = pluginInterface.getSiteRate(url,4);

    var aSzResult = szResult.split(';*');
    if (aSzResult.length > 1)
    {
        var iResult = parseInt(aSzResult[1]);
        if (iResult)
        {
            switch(iResult)
            {
                case 1: //malicious
                case 2: //unsafe
                //case 3: //suspicious todo - suspicious need to send alert to policy manager?
                //send url in format iRating>url, eg: 2>http://www.yahoo.com
                    try {
                        pluginInterface.excCommand(bUserContinue?1221:1220, iResult + '>' + url);
                    } catch(e) {}
                    //alert(iResult + '>' + url);
                    break;
                default:
                    break;
             }
         }
     }
}

function XX_GetBlockUrl(strCurrentPageUrl)
{
    try {
        var localInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        if(localInterface){
            var strBlockPage = localInterface.excCommand(1116,0);
            var strParameter = localInterface.excCommand(1204,strCurrentPageUrl);
            //strPath = strBlockPage + "?url=" + window.content.document.location.href;
            strPath = strBlockPage + strParameter;//"?ISPID=111&LANG=ENG&TOKEN=FDSFDFDFDFDFD&REASON=FFF";
            NotifyPolicyManager(strCurrentPageUrl, false); //leekea - notify policy manager when a page is blocked
            //return strPath;
            return unescape(strPath);

        }
    }catch (e){
    //dump(e);
    }
//return "http://localhost:6789/block.html?url=" + window.content.document.location.href;
}

//2D array for storing links
var col = new Array();
var fsRandomStart = Math.randomMax(65535);

function CreateLink(pageLinks,nSite)
{
    this.cand = pageLinks;
    this.position = 0;
    this.Site = nSite;
}

var pluginInterface = null;

function XX_GetUserPref()
{
    try {
        var localInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        if(localInterface)
            return localInterface.excCommand(1102,0);
    }catch (e){
    //dump(e);
    }
}

function XX_GetFspcPref()
{
    try {
        var localInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        if(localInterface)
            return localInterface.excCommand(1217,0);
    }catch (e){
    //dump(e);
    }
}

function XX_GetPSC9_1_Pref()
{
    try {
        var localInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        if(localInterface)
            return localInterface.excCommand(1219,0);
    }catch (e){
    //dump(e);
    }
}

function XX_GetMinimizeToolbarPref()
{
    try {
        var localInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        if(localInterface)
            return localInterface.excCommand(1205,null);
    }catch (e){
    //dump(e);
    }
}

function XX_IsFspcLoaded()
{
    try {
        var localInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        if(localInterface)
        {
            if(localInterface.excCommand(1216,null) != "0")
            {
              g_OnFspcLoaded = true;
            }
        }
    }catch (e){
    //dump(e);
    }
}

function XX_GetUserOption(nMatch)
{
    try {
        var localInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        if(localInterface) {
            if(nMatch == 1)
            {
                return localInterface.getPreference("PageBlockMal","");
            }else if(nMatch == 2)
            {
                return localInterface.getPreference("PageBlockSus","");
            }else if(nMatch == 3)
            {
                return localInterface.getPreference("PageBlockUnrated","");
            }
        //	return localInterface.getPreference("ActiveProtect","");
        }
    }catch (e){
    //dump(e);
    }
    return true; // default turn all up on error
}

var bFirst = false;

function XX_firstOpen()
{
    if(bFirst) return;
    bFirst = true;
    var sCurrentUrl = parseUrl(window.content.document.location.href);
    if(pluginInterface == null)
    {
        try {
            pluginInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        }catch (e){
            dump(e);
        }
    }
    if(XX_GetUserPref() == "0" ||
        sCurrentUrl.indexOf("chrome://")==0 || sCurrentUrl.indexOf("about:")==0 || sCurrentUrl.indexOf("file://")==0
        ) {
        /*
		if(XX_GetUserPref() != "3")
		{
			document.getElementById('litmus-ff-button').setAttribute("image","chrome://litmus-ff/skin/big/on.png");
			document.getElementById('litmus-ff-tooltip-text').setAttribute("value","");
		}
        **/
        return;
    }
    var szResult = pluginInterface.getSiteRate(sCurrentUrl.href,1);
    if( szResult != "" )
    {
        var arParam = szResult.split("*");
        document.getElementById('litmus-ff-button').setAttribute("image",arParam[0].replace(/(small)/gi,"bp"));
        //document.getElementById('litmus-ff-tooltip-docloc').setAttribute("value",sCurrentUrl);
        //document.getElementById('litmus-ff-tooltip-text').setAttribute("value",szResult);

        // Rex: BP Gui integration
        document.getElementById('FS-Rating-Button').setAttribute("image",arParam[0].replace(/(small)/gi,"bp"));

        if(arParam[3])
        {
            if(parseInt(arParam[3])<3 && parseInt(arParam[3])>0)
            {
                if(parseInt(parseInt(arParam[3])) == 1 && XX_GetUserOption(1)&1)
                {
                    XX_loadURL(XX_GetBlockUrl(sCurrentUrl));
                }
				
                if(parseInt(parseInt(arParam[3])) == 1 && XX_GetUserOption(1)&2)
                {
                    var szSite = sCurrentUrl.split("://")[1]?sCurrentUrl.split("/")[2].split("?")[0]:sCurrentUrl.split("/")[0].split("?")[0];
                    //var szMsg = szSite + " was detected as " + arParam[1] + " site.\r\nDo you want to continue navigate?"
                    //var answer = confirm(szMsg);
                    //if(!answer)
                    var answer = pluginInterface.excCommand(1107, szSite + "*" + arParam[1] + "*" + arParam[3]);
                    if(answer == "cancel")
                    {
                        document.getElementById('litmus-ff-button').setAttribute("image",arParam[0].replace(/(small)/gi,"bp"));
                        XX_loadURL(XX_GetBlockUrl(sCurrentUrl));

                        // Rex: BP Gui integration
                        document.getElementById('FS-Rating-Button').setAttribute("image",arParam[0].replace(/(small)/gi,"bp"));

                    }
                }
				
                if(parseInt(parseInt(arParam[3])) == 2 && XX_GetUserOption(1)&1)
                {
                    XX_loadURL(XX_GetBlockUrl(sCurrentUrl));
                }
				
                if(parseInt(parseInt(arParam[3])) == 2 && XX_GetUserOption(1)&2)
                {
                    var szSite = sCurrentUrl.split("://")[1]?sCurrentUrl.split("/")[2].split("?")[0]:sCurrentUrl.split("/")[0].split("?")[0];
                    //var szMsg = szSite + " was detected as " + arParam[1] + " site.\r\nDo you want to continue navigate?"
                    //var answer = confirm(szMsg);
                    //if(!answer)
                    var answer = pluginInterface.excCommand(1107, szSite + "*" + arParam[1]  + "*" + arParam[3]);
                    if(answer == "cancel")
                    {
                        document.getElementById('litmus-ff-button').setAttribute("image",arParam[0].replace(/(small)/gi,"bp"));
                        XX_loadURL(XX_GetBlockUrl(sCurrentUrl));

                        // Rex: BP Gui integration
                        document.getElementById('FS-Rating-Button').setAttribute("image",arParam[0].replace(/(small)/gi,"bp"));

                    }
                }
            }
        }
    }/* else {
        document.getElementById('litmus-ff-button').setAttribute("image","chrome://litmus-ff/skin/bp/on.png");
        document.getElementById('litmus-ff-tooltip-text').setAttribute("value",szResult);
    }*/
}

function XX_TabSelected(aEvent)
{
    if(pluginInterface == null)
    {
        try {
            pluginInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        }catch (e){
        //dump(e);
        }
    }
    var strBlockPage = XX_GetBlockUrlEx();
    var strCurrentPage = parseUrl(decodeURI(window.content.document.location.href));

    if(XX_GetUserPref() == "0" ||
        strCurrentPage.indexOf("http://localhost/")==0 || strCurrentPage.indexOf("chrome://")==0 || strCurrentPage.indexOf("about:")==0 || strCurrentPage.indexOf("file://")==0
        && strCurrentPage.indexOf(strBlockPage)!=0) {

        // Rex: 17/03/09 - Change toolbar icon when switch tab
        XX_UpdateToolbarButton("chrome://litmus-ff/skin/bp/lvl0.png", "chrome://litmus-ff/skin/bp/lvl0.png", "This site has not been analysed");
        ///*
        /*if(XX_GetUserPref() != "0")
        {
            try{
                document.getElementById('litmus-ff-button').setAttribute("image","chrome://litmus-ff/skin/bp/on.png");
                document.getElementById('litmus-ff-tooltip-text').setAttribute("value","");
            }catch(e){}
        }*/
        /**/
        return;
    }
    //var strBlockPage = XX_GetBlockUrlEx();
	
    if(strCurrentPage.indexOf(strBlockPage)==0)
    {
        // Rex: force update icon in block page
        XX_UpdateToolbarButton("chrome://litmus-ff/skin/bp/lvl1.png", "chrome://litmus-ff/skin/bp/lvl1.png", "This site is: SAFE");
		    return;
        //var menuCheck = document.getElementById('InstantWhite');
        //turn off menu item
        //if( menuCheck )
        //{
        //    menuCheck.setAttribute("disabled","true");
        //}
        /*if(XX_GetUserPref() != "0")
        {
            try{
                document.getElementById('litmus-ff-button').setAttribute("image","chrome://litmus-ff/skin/bp/on.png");
                document.getElementById('litmus-ff-tooltip-text').setAttribute("value","");
            }catch(e){}
            return;
        }*/
    }

    //setTimeout(YY_handleDOMLoaded,1,window.content.document.location.href,window.content.document);
		
    //dump("Loc change request " + aLocation.prePath + aLocation.path + " ee\n");
    //href need preprocess;
    var szHref = parseUrl(decodeURI(window.content.document.location.href));
    if (szHref.match(/^http:\/\/rds.yahoo.com/))
    {
        szHref = szHref.split("/**")[1];
    }

    var szResult = pluginInterface.getSiteRate(szHref,4);
    //var szResult = pluginInterface.getSiteRate(window.content.document.location.href,1);
    //dump("tab select on "+ window.content.document.location.href+"\n");
    //dump("Http Result = " + szResult + "\n");
    var szSite = "";
    szSite = szHref.split("://")[1]?szHref.split("/")[2].split("?")[0]:szHref.split("/")[0].split("?")[0];

    if( szResult != "" )
    {
        try{
            //document.getElementById('litmus-ff-tooltip-docloc').setAttribute("value",szHref);
            var arParam = szResult.split("*");
            //check is request address same as toolbat address
            document.getElementById('litmus-ff-button').setAttribute("image",arParam[0].replace(/(small)/gi,"bp"));
            document.getElementById("xxImg").setAttribute("src",arParam[0].replace(/(small)/gi,"pop"));
            //document.getElementById('litmus-ff-tooltip-text').setAttribute("value",szResult);
        }catch(e){}
        // Rex: BP Gui integration - // Rex: 17/03/09 - Change toolbar icon when switch tab
        XX_UpdateToolbarButton(arParam[0].replace(/(small)/gi,"bp"), arParam[0].replace(/(small)/gi,"bp"), "");
        //document.getElementById('FS-Rating-Button').setAttribute("image",arParam[0].replace(/(small)/gi,"bp"));

        if(arParam[3])
        {
    /*
  			 if(parseInt(arParam[3])<3 && parseInt(arParam[3])>0)
  			 {
  				  if(parseInt(parseInt(arParam[3])) == 1 && XX_GetUserOption(1)&1)
  				  {
    					 XX_loadURL(XX_GetBlockUrl());
  				  }
  				  
  				  if(parseInt(parseInt(arParam[3])) == 1 && XX_GetUserOption(1)&2)
  				  {
              //szSite = window.content.document.location.href.split("://")[1]?window.content.document.location.href.split("/")[2].split("?")[0]:window.content.document.location.href.split("/")[0].split("?")[0];
    					var answer = pluginInterface.excCommand(1107, szSite + "*" + arParam[1]  + "*" + arParam[3]);
    					if(answer == "cancel")
    					{
    						document.getElementById('litmus-ff-button').setAttribute("image",arParam[0].replace(/(small)/gi,"big"));
    						XX_loadURL(XX_GetBlockUrl());

						// Rex: BP Gui integration
						document.getElementById('FS-Rating-Button').setAttribute("image",arParam[0].replace(/(small)/gi,"bp"));

    					}
  					}
  			 }
	
			 
  			 if(parseInt(parseInt(arParam[3])) == 2 && XX_GetUserOption(1)&1)
  			 {
  			   XX_loadURL(XX_GetBlockUrl());
         }
    			
          if(parseInt(parseInt(arParam[3])) == 2 && XX_GetUserOption(1)&2)
  				{
  					//szSite = window.content.document.location.href.split("://")[1]?window.content.document.location.href.split("/")[2].split("?")[0]:window.content.document.location.href.split("/")[0].split("?")[0];
  					var answer = pluginInterface.excCommand(1107, szSite + "*" + arParam[1]  + "*" + arParam[3]);
  					if(answer == "cancel")
  					{
  						document.getElementById('litmus-ff-button').setAttribute("image",arParam[0].replace(/(small)/gi,"big"));
  						XX_loadURL(XX_GetBlockUrl());

						// Rex: BP Gui integration
						document.getElementById('FS-Rating-Button').setAttribute("image",arParam[0].replace(/(small)/gi,"bp"));

  					}
  				}
        		*/
    }
    }/* else {
        document.getElementById('litmus-ff-button').setAttribute("image","chrome://litmus-ff/skin/bp/on.png");
        document.getElementById('litmus-ff-tooltip-text').setAttribute("value",szResult);
    }*/
}

function BuildMiniToolbarItem()
{
    //make sure Litmus is always visible
  var elem = document.getElementById("urlbar-container");

	var nbr = document.getElementById("nav-bar");
	var box = document.getElementById("navigator-toolbox");
	if (box) {
	
  	var btnArray = ["litmus-fs-button", "litmus-ff-button", "litmus-pc-button"];
    for(i = 0; i < 3; i++)
    {
  		var bar = box.firstChild;
  		while (bar) {
  			if (bar.currentSet && bar.currentSet.indexOf(btnArray[i]) != -1) {
  				break;
  			}
  			bar = bar.nextSibling;
  		}
  		if(!bar && nbr && nbr.currentSet.indexOf(btnArray[i]) == -1)
  			nbr.insertItem(btnArray[i], elem, null, false);
  	}
	}
}


function XX_onPluginLoad()
{
    //make sure Litmus is always visible
    BuildMiniToolbarItem();
 /* var elem = document.getElementById("urlbar-container");

	var nbr = document.getElementById("nav-bar");
	var box = document.getElementById("navigator-toolbox");
	if (box) {
	
  	var btnArray = ["litmus-fs-button", "litmus-ff-button", "litmus-pc-button"];
    for(i = 0; i < 3; i++)
    {
  		var bar = box.firstChild;
  		while (bar) {
  			if (bar.currentSet && bar.currentSet.indexOf(btnArray[i]) != -1) {
  				break;
  			}
  			bar = bar.nextSibling;
  		}
  		if(!bar && nbr && nbr.currentSet.indexOf(btnArray[i]) == -1)
  			nbr.insertItem(btnArray[i], elem, null, false);
  	}
	}*/
	

	XX_IsFspcLoaded();
	if(!g_OnFspcLoaded || XX_GetFspcPref() == "0" || XX_GetPSC9_1_Pref() == "0")
	{
            try{
                document.getElementById('FS-Parental-Button').setAttribute("hidden",true);
                document.getElementById('litmus-pc-button').setAttribute("hidden",true);
                document.getElementById('main-popup-turnon_fspc').setAttribute("hidden",true);
            }catch(e){}
  }
	
	// determine mozilla version
  if (/Firefox[\/\s](\d+\.\d+)/.test(navigator.userAgent)){ //test for Firefox/x.x or Firefox x.x (ignoring remaining digits);
    g_MozillaVersion = new Number(RegExp.$1) // capture x.x portion and store as a number
}	
	
	if(pluginInterface != null) return;
	try {
		pluginInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
		//if(pluginInterface)
                  //pluginInterface.LitmusWindowLoad(window);
		window.getBrowser().addProgressListener(fsProgressListener, ST_MASK_WND | ST_MASK_STATUS | ST_MASK_LOCATION | ST_MASK_PROGRESS);
		dump("State mask = " + ST_START + "\n");
	}catch (e){
		dump(e);
	}
	
    if(pluginInterface)
    {
        var fsIcon = pluginInterface.excCommand(1210,null);
        if(fsIcon != "")
        {
            try{
                document.getElementById('FS-MainMenu').setAttribute("image",unescape(fsIcon)); // customize icon
                document.getElementById('litmus-fs-button').setAttribute("image",unescape(fsIcon)); // customize icon
            }catch(e){}
        }
        else
        {
            try{
                document.getElementById('FS-MainMenu').setAttribute("image","chrome://litmus-ff/skin/bp/fsecure.png"); // default icon
                document.getElementById('litmus-fs-button').setAttribute("image","chrome://litmus-ff/skin/bp/fsecure.png"); // default icon
            }catch(e){}
        }
    }
	
    // Rex: check the watch mode when plugin loaded
    XX_DoWatchMode();
 
    document.addEventListener("DOMContentLoaded", XX_onDOMLoaded, false);
    //	setTimeout("XX_firstOpen();",1000);
    try{
    getBrowser().addEventListener("mouseover", XXGenericCop, false);
    getBrowser().addEventListener("click", XXGenericCop, false);
    getBrowser().tabContainer.addEventListener("TabSelect", XX_TabSelected, false);
    getBrowser().addEventListener("DOMTitleChanged", XX_TitleChanged, false); // Rex:
    }catch(e){}

    //getBrowser().addEventListener("focus", XX_Focus, true);
	document.addEventListener("DOMContentLoaded", XX_onDOMLoaded, false);
	
//	setTimeout("XX_firstOpen();",1000);
	getBrowser().addEventListener("mouseover", XXGenericCop, false);
	getBrowser().addEventListener("click", XXGenericCop, false);
  getBrowser().tabContainer.addEventListener("TabSelect", XX_TabSelected, false);
  getBrowser().addEventListener("DOMTitleChanged", XX_TitleChanged, false); // Rex: 

    timerBPOnOffId = setTimeout(OnRefreshConfig,5000, "");
    timerToolbarRefreshId = setTimeout(OnRefreshToolbar,1000, "");
//  getBrowser().addEventListener("blur", XX_Blur, true);
//	getBrowser().addEventListener("mouseout", XXGenericCop, false);
//	getBrowser().addEventListener("keydown", XXGenericCop, false);
//	getBrowser().addEventListener("mousemove", XXGenericCop, false);
}

function XX_DoWatchMode()
{
    var btnFSRating = document.getElementById('FS-Rating-Button');
    var btnFSReport = document.getElementById('FS-Report-Button');
    if(XX_GetUserPref() == "0")
    {
        //Rex: BP gui integration - hide button
        if(btnFSRating)
        {
            btnFSRating.setAttribute("hidden","true");
        }
        if(btnFSReport)
        {
            btnFSReport.setAttribute("hidden","true");
        }
        //if(btnFSParent)
        //{
        //    btnFSParent.setAttribute("hidden","true");
        //}        
    }else
    {
        if(XX_GetMinimizeToolbarPref() != "0")
        {
          //Rex: BP gui integration - show button
          if(btnFSRating)
          {
              btnFSRating.setAttribute("hidden","true");
          }
          if(btnFSReport)
          {
              btnFSReport.setAttribute("hidden","true");
          }      
        } 
        else 
        {
          //Rex: BP gui integration - show button
          if(btnFSRating)
          {
              btnFSRating.setAttribute("hidden","false");
          }
          if(btnFSReport)
          {
              btnFSReport.setAttribute("hidden","false");
          }         
        }
        //Rex: BP gui integration - show button
        /*if(btnFSRating)
        {
            btnFSRating.setAttribute("hidden","false");
        }
        if(btnFSReport)
        {
            btnFSReport.setAttribute("hidden","false");
        }*/
        //if(btnFSParent)
        //{
        //    btnFSParent.setAttribute("hidden","false");
        //}        
    }
}

function  XX_DoProcessRefreshConfig()
{
    try {
        var localInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        if(localInterface)
        {
            if(localInterface.excCommand(1114,null) != "1"){
                if(XX_GetUserPref() == "0")
                {
                    /*try{
                    document.getElementById('Watch-Off').setAttribute("checked","true");
                    document.getElementById('litmus-ff-button').setAttribute("image","chrome://litmus-ff/skin/bp/off.png");
                    document.getElementById('litmus-ff-tooltip-text').setAttribute("value","Litmus Disabled");
                    }catch(e){}*/
                    //Rex: BP gui integration - hide button
                    XX_DoWatchMode();
                //document.getElementById('FS-Rating-Button').setAttribute("hidden","true");
                //document.getElementById('FS-Report-Button').setAttribute("hidden","true");
		    
                }else
                {
                    try{
                    document.getElementById('Watch-Block').setAttribute("checked","true");
                    var menuitem = document.getElementById("InstantWhite");
                    menuitem.setAttribute("disabled", false);
        
                    menuitem = document.getElementById("Watch-Block");
                    menuitem.setAttribute("disabled", false);
        
                    menuitem = document.getElementById("Watch-Off");
                    menuitem.setAttribute("disabled", false);
                    }catch(e){}

                    XX_RefreshToolbarIcon();
                //Rex: BP gui integration - show button
                //document.getElementById('FS-Rating-Button').setAttribute("hidden","false");
                //document.getElementById('FS-Report-Button').setAttribute("hidden","false");
                }
                //Rex: BP gui integration - hide button
                XX_DoWatchMode();
            }
        }
    }catch (e){
    //dump(e);s
    }
	
    timerBPOnOffId = setTimeout(OnRefreshConfig,5000, "");
}

function XX_DoProcessRefreshToolbar()
{
    try {
        var localInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        if(localInterface)
        {
            // update F-icon
            var fsIcon = localInterface.excCommand(1210,null);
            if(fsIcon != "")
            {
                try{
                    document.getElementById('FS-MainMenu').setAttribute("image", unescape(fsIcon)); // customize icon
                    document.getElementById('litmus-fs-button').setAttribute("image",unescape(fsIcon)); // customize icon
                }catch(e){}
            }
            else
            {
                try{
                    document.getElementById('FS-MainMenu').setAttribute("image","chrome://litmus-ff/skin/bp/fsecure.png"); // default icon
                    document.getElementById('litmus-fs-button').setAttribute("image","chrome://litmus-ff/skin/bp/fsecure.png"); // default icon
                }catch(e){}
            }

            var FS_toolbar = document.getElementById('FS-Toolbar');
            
            var test = document.getElementById('litmus-fs-button');
            if(!test)
              BuildMiniToolbarItem();    

            if(XX_GetUserPref() != "0")
            {
                if(XX_GetMinimizeToolbarPref() != "0")
                {
                    // do minimize
                    FS_toolbar.setAttribute("hidden", "true");
                    document.getElementById('FS-MainMenu').setAttribute("hidden", "true");
                    document.getElementById('FS-Rating-Button').setAttribute("hidden", "true");
                    document.getElementById('FS-Report-Button').setAttribute("hidden", "true");
                    
                    document.getElementById('litmus-fs-button').setAttribute("hidden", "false");
                    document.getElementById('litmus-ff-button').setAttribute("hidden", "false");
                /*    if(g_OnFspcLoaded && XX_GetFspcPref() != "0")
                    {
                      document.getElementById('litmus-pc-button').setAttribute("hidden", "false");
                    }
                */
                    /*
                    if(FS_toolbar){
                        FS_toolbar.setAttribute("mode", "icons");
                    }
                    var btnFSRating = document.getElementById('FS-Rating-Button');
                    var btnFSReport = document.getElementById('FS-Report-Button');
                    var btnFSParent = document.getElementById('FS-Parental-Button');
                    var btnFSMainMenu = document.getElementById('FS-MainMenu');

                    if(btnFSRating){
                        if(btnFSRating.parentNode.id !== 'wrapper-' + btnFSRating.id){
                            btnFSRating.setAttribute("label","");
                        }
                    }

                    if(btnFSReport){
                        if(btnFSReport.parentNode.id !== 'wrapper-' + btnFSReport.id){
                            btnFSReport.setAttribute("label", "");
                        }
                    }
                    
                    if(btnFSParent){
                        if(btnFSParent.parentNode.id !== 'wrapper-' + btnFSParent.id){
                            btnFSParent.setAttribute("label", "");
                        }
                    }                

                    if(btnFSMainMenu){
                        if(btnFSMainMenu.parentNode.id !== 'wrapper-' + btnFSMainMenu.id){
                            btnFSMainMenu.setAttribute("label", "");
                        }
                    }*/

                }
                else
                {
                    // do maximize
                    XX_TabSelected(this);
                    var strLabel = localInterface.excCommand(1103,243);
                    if(FS_toolbar){
                        FS_toolbar.setAttribute("mode","full");
                    }                    
                    document.getElementById('FS-MainMenu').setAttribute("label", "");
                    document.getElementById('FS-MainMenu').setAttribute("hidden", "false");
                    document.getElementById('FS-Rating-Button').setAttribute("hidden", "false");
                    document.getElementById('FS-Report-Button').setAttribute("hidden", "false");
                                        
                    document.getElementById('FS-Report-Button').setAttribute("label", unescape(strLabel));
                    document.getElementById('litmus-fs-button').setAttribute("hidden", "true");
                    document.getElementById('litmus-ff-button').setAttribute("hidden", "true");
                    /*if(g_OnFspcLoaded && XX_GetFspcPref() != "0")
                    {
                      document.getElementById('litmus-pc-button').setAttribute("hidden", "true");
                    }*/                    
                    FS_toolbar.setAttribute("hidden", "false");
                                        
                    /*XX_TabSelected(this);
                    var strLabel = localInterface.excCommand(1103,243);
                    if(FS_toolbar){
                        FS_toolbar.setAttribute("mode","full");
                    }
                    try{
                        document.getElementById('FS-MainMenu').setAttribute("label", "");
                    }catch(e){}
                    try{
                    document.getElementById('FS-Report-Button').setAttribute("label", unescape(strLabel));
                    }catch(e){}*/
     
                }
            }
            else{
            
                //turned off
                if(XX_GetMinimizeToolbarPref() != "0")
                {
                    // do minimize
                    FS_toolbar.setAttribute("hidden", "true");
                    document.getElementById('litmus-fs-button').setAttribute("hidden", "false");
                    document.getElementById('litmus-ff-button').setAttribute("hidden", "true");
                    /*if(g_OnFspcLoaded && XX_GetFspcPref() != "0")
                    {
                      document.getElementById('litmus-pc-button').setAttribute("hidden", "false");
                    } */                 
                } else {
                  if(FS_toolbar){
                      FS_toolbar.setAttribute("hidden", "false");
                      document.getElementById('FS-MainMenu').setAttribute("hidden", "false");
                
                      if(FS_toolbar.getAttribute("mode") != "full"){
                          FS_toolbar.setAttribute("mode", "full");
                          
                          
                          
                        //document.getElementById('FS-MainMenu').setAttribute("hidden", "false");
                      }
                  }
  
                  var l_btnFSMainMenu = document.getElementById('FS-MainMenu');
                  if(l_btnFSMainMenu){
                      l_btnFSMainMenu.setAttribute("label", "");
                  }
                  
                    document.getElementById('litmus-fs-button').setAttribute("hidden", "true");
                    document.getElementById('litmus-ff-button').setAttribute("hidden", "true");
                    /*if(g_OnFspcLoaded && XX_GetFspcPref() != "0")
                    {
                      document.getElementById('litmus-pc-button').setAttribute("hidden", "true");
                    } */                  
                }
               
            }
            
            if(g_OnFspcLoaded && XX_GetFspcPref() == "1" && XX_GetPSC9_1_Pref() == "1")
            {

              // Parental control button refresh
              try{
                var strFspcImages = ["chrome://litmus-ff/skin/bp/adult.png", "chrome://litmus-ff/skin/bp/teenager.png", "chrome://litmus-ff/skin/bp/small-child.png"];
                var strLabel1 = localInterface.excCommand(1103,262);
                var strLabel2 = "";
                var iProfile = localInterface.excCommand(1214,null);
                switch(iProfile)
                {
                  case "0": strLabel2 = localInterface.excCommand(1103,263); break;
                  case "1": strLabel2 = localInterface.excCommand(1103,264); break;
                  default: strLabel2 = localInterface.excCommand(1103,265); break;
                }
                
                document.getElementById('FS-Parental-Button').setAttribute("label", unescape(strLabel1) + ": " + unescape(strLabel2) + " ");
                document.getElementById('FS-Parental-Button').setAttribute("image", strFspcImages[iProfile]);
                document.getElementById('litmus-pc-button').setAttribute("image", strFspcImages[iProfile]);
                
                if(XX_GetMinimizeToolbarPref() != "0")
                {
                  document.getElementById('litmus-pc-button').setAttribute("hidden", "false");
                  document.getElementById('FS-Parental-Button').setAttribute("hidden", "true");
                } 
                else
                {
                  document.getElementById('FS-Parental-Button').setAttribute("hidden", "false"); 
                  document.getElementById('litmus-pc-button').setAttribute("hidden", "true");    
                } 
                         
              }catch(e){}
            } else {
                document.getElementById('litmus-pc-button').setAttribute("hidden", "true");
                document.getElementById('FS-Parental-Button').setAttribute("hidden", "true");            
            }            
        }
    }catch (e){
    //dump(e);
    }
	
    timerToolbarRefreshId = setTimeout(OnRefreshToolbar,5000, "");
}

function OnRefreshConfig(id)
{  
    XX_DoProcessRefreshConfig();
}

function OnRefreshToolbar()
{  
    XX_DoProcessRefreshToolbar();
}
setTimeout(OnRefreshToolbar,5000, "");

function XX_onDOMSubmit(event)
{

    return;
    //	dump("site is submitting.....*" + event.target + "*..\n");
    var szSiteName = event.target.action || window.content.document.location.href;
    szSiteName = parseUrl(szSiteName);
    //	dump("address is recv.....*" + szSiteName + "*..\n");
    //	if(event.cancelable)
    //		event.preventDefault();
    if(pluginInterface == null)
    {
        try {
            pluginInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        }catch (e){
        //dump(e);
        }
    }
	
    if(XX_GetUserPref() == "0" ||
        event.target.action.indexOf("http://localhost/")==0 || event.target.action.indexOf("chrome://")==0 || event.target.action.indexOf("about:")==0 || event.target.action.indexOf("file://")==0
        ) {
        //if(XX_GetUserPref() == "3" || event.target.action.indexOf("chrome://")==0 || event.target.action.indexOf("file://")==0
        //) {
        return;
    }
    //	var szDomain = event.target.action.split("://")[1]?event.target.action.split("/")[2].split("?")[0]:event.target.action.split("/")[0].split("?")[0];
    var szDomain = szSiteName.split("?")[1]? szSiteName.split("?")[0]:szSiteName;
    //	dump("site is submitting.....*" + szDomain + "*..\n");
    var szResult = pluginInterface.getSiteRate(szDomain,4);
    //	dump("Site result = ## " + szResult + " ##\n");
    if( szResult != "" )
    {
        var arParam = szResult.split("*");
        ///*
        if(arParam[3])
        {
            //			if(parseInt(arParam[3]) == 1) //malicious - too stink, we just block it
            //			{
            //				if(event.cancelable) event.preventDefault();
            //				XX_loadURL(XX_GetBlockUrl());
            //			}
      
            var szSite = szSiteName.split("://")[1]?szSiteName.split("/")[2].split("?")[0]:szSiteName.split("/")[0].split("?")[0];
            if(parseInt(arParam[3]) == 1 && XX_GetUserOption(1)&8)
            {
                setTimeout(XX_StopBrowserEx,1, szSiteName);
                if(event.cancelable) event.preventDefault();
                XX_loadURL(XX_GetBlockUrl(szSiteName));
            }
			
            if(parseInt(arParam[3]) == 1 && XX_GetUserOption(1)&16)
            {
                //var szSite = event.target.action.split("://")[1]?event.target.action.split("/")[2].split("?")[0]:event.target.action.split("/")[0].split("?")[0];
                //var szMsg = szSite + " was detected as " + arParam[1] + " site.\r\nDo you want to continue submitting?"
                //var answer = confirm(szMsg);
                //if(!answer)
                var answer = pluginInterface.excCommand(1108, szSite + "*" + arParam[1]  + "*" + arParam[3]);
                if(answer == "cancel")
                {
                    setTimeout(XX_StopBrowserEx,1, szSiteName);
                    if(event.cancelable) event.preventDefault();
                    XX_loadURL(XX_GetBlockUrl(szSiteName));
                }
            }
            if(parseInt(arParam[3]) == 2 && XX_GetUserOption(1)&8)
            {
                setTimeout(XX_StopBrowserEx,1, szSiteName);
                if(event.cancelable) event.preventDefault();
                XX_loadURL(XX_GetBlockUrl(szSiteName));
            }
		
    
            if(parseInt(arParam[3]) == 2 && XX_GetUserOption(1)==18)
            {
			
		
                //var szSite = event.target.action.split("://")[1]?event.target.action.split("/")[2].split("?")[0]:event.target.action.split("/")[0].split("?")[0];
                //var szMsg = szSite + " was detected as " + arParam[1] + " site.\r\nDo you want to continue submitting?"
                //var answer = confirm(szMsg);
                //if(!answer)
                var answer = pluginInterface.excCommand(1108, szSite + "*" + arParam[1]  + "*" + arParam[3]);
                if(answer == "cancel")
                {
                    setTimeout(XX_StopBrowserEx,1, szSiteName);
                    if(event.cancelable) event.preventDefault();
                    XX_loadURL(XX_GetBlockUrl(szSiteName));
                }
            }
			
            if(parseInt(arParam[3]) == 3 && XX_GetUserOption(2)&8)
            {
                setTimeout(XX_StopBrowserEx,1, szSiteName);
                if(event.cancelable) event.preventDefault();
                XX_loadURL(XX_GetBlockUrl(szSiteName));
            }
            if(parseInt(arParam[3]) == 3 && XX_GetUserOption(2)&16)
            {
                //var szSite = event.target.action.split("://")[1]?event.target.action.split("/")[2].split("?")[0]:event.target.action.split("/")[0].split("?")[0];
                //var szMsg = szSite + " was detected as " + arParam[1] + " site.\r\nDo you want to continue submitting?"
                //var answer = confirm(szMsg);
                //if(!answer)
                var answer = pluginInterface.excCommand(1108, szSite + "*" + arParam[1]  + "*" + arParam[3]);
                if(answer == "cancel")
                {
                    setTimeout(XX_StopBrowserEx,1, szSiteName);
                    if(event.cancelable) event.preventDefault();
                    XX_loadURL(XX_GetBlockUrl(szSiteName));
                }
            }
			
            if(parseInt(arParam[3]) == 0 && XX_GetUserOption(3)&8 )
            {
			
                setTimeout(XX_StopBrowserEx,1, szSiteName);
                if(event.cancelable) event.preventDefault();
                XX_loadURL(XX_GetBlockUrl(szSiteName));
            }
			
            if(parseInt(arParam[3]) == 0 && XX_GetUserOption(3)&16)
            {
                //var szSite = event.target.action.split("://")[1]?event.target.action.split("/")[2].split("?")[0]:event.target.action.split("/")[0].split("?")[0];
                //var szMsg = szSite + " was detected as " + arParam[1] + " site.\r\nDo you want to continue submitting?"
                //var answer = confirm(szMsg);
                //if(!answer)
                var answer = pluginInterface.excCommand(1108, szSite + "*" + arParam[1]  + "*" + arParam[3]);
                if(answer == "cancel")
                {
                    setTimeout(XX_StopBrowserEx,1, szSiteName);
                    if(event.cancelable) event.preventDefault();
                    XX_loadURL(XX_GetBlockUrl(szSiteName));
                }
            }
        }
    }
}

function XX_onPluginUnload()
{
    //if (pluginInterface)
    //pluginInterface.LitmusWindowUnload(window);
    pluginInterface = null;
}

function YY_continueLinkRating(dochref, doc)
{
    var LI = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
    if (LI)
    {
        if (LI.LitmusLinkRate(dochref, doc, false) == true)
        {
            setTimeout(YY_continueLinkRating, 1000, dochref, doc);
        }
    }
}

function ZZ_IconClick() {
    var LI = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
    if (LI)
    {
        if (this.hasAttribute("litmus_url"))
        {
            LI.excCommand(1104, this.getAttribute("litmus_url"));
        }
    }
}

function YY_handleDOMLoaded(docHref, docCurrent)
{
    var arrayID = Math.randomMax(65535);
    var bChoice = false;
    var engineChoice1 = 0;
    var engineChoice2 = 0;
    var engineChoice3 = 0;
    try {
        var localInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        if(localInterface) {
            bChoice = true;//!(localInterface.getPreference("SafetyRate","") & 4);
            engineChoice1 = localInterface.getPreference("EngineChoice","0");
            engineChoice2 = localInterface.getPreference("EngineChoice","1");
            engineChoice3 = localInterface.getPreference("EngineChoice","2");
            if(localInterface.getPreference("SafetyRate","") & 2)
            {
                engineChoice1 = -1;
                engineChoice2 = -1;
                engineChoice3 = -1;
            }
        }
    }catch (e){
    //dump(e);
    }
    //var mail_page = getMailIndex(docHref);

    var mail_page = 0;
	
    // Rex: Check if we need to show link reputation in result page
    if(XX_GetUserPref() != "0" && localInterface.excCommand(1208, null) != 0)
        mail_page = getMailIndex(docHref);
	
    if(mailChecker)
        clearTimeout(mailChecker);
    if(mailWatcher)
        clearTimeout(mailWatcher);
    
    if (false) // change this to true to enable new functionality
    {
        var LI = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        if (LI)
        {
            if (LI.LitmusLinkRatingRequired(docHref) == true)
            {
                if (LI.LitmusLinkRate(docHref, docCurrent, true) == true)
                {
                    // schedule new call
                    setTimeout(YY_continueLinkRating, 100, docHref, docCurrent);
                }

                var imgs = docCurrent.getElementsByTagName("img");

                for (var lid = 0; lid < imgs.length; lid++)
                {
                    if (imgs[lid].hasAttribute("litmus_url"))
                    {
                        imgs[lid].addEventListener("click", ZZ_IconClick, false);
                    }
                }
                return;
            }
        }
    }
    
    
    //dump("mail page " + mail_page + "\n");
    if ( mail_page != 0 )
    {
        do
        {
            if(bChoice && mail_page == GOOGLE && !(engineChoice2 & 1)) break;
            if(bChoice && (mail_page == YAHOO_C || mail_page == YAHOO_A) && !(engineChoice2 & 2)) break;
            if(bChoice && mail_page == HOTMAIL && !(engineChoice2 & 4)) break;
            FS_extMailRate(mail_page, docCurrent, FS_MailFrameMatch[mail_page]==null?true:false);
            stopWatch();
            startWatch();
            if(mail_page == GOOGLE)
            {
                //mailChecker = setTimeout(DD_Scan,100,window.content);
                //mailWatcher = setTimeout(WatchMailer,100,window._content.document);
                setTimeout(XX_GMailWatcher,100,docCurrent);
            }
        } while (false);
    }
	
    var other_page = 0;
    /*
	var other_page = getOtherIndex(event.target.location.href);
	//dump("other page " + other_page + "\n");
	if ( other_page != 0 )
	{
		do
		{	
			if(bChoice && other_page == WIKI && !(engineChoice3 & 1)) break;
			if(bChoice && other_page == DMOZ && !(engineChoice3 & 2)) break;
			if(bChoice && other_page == DELICIOUS && !(engineChoice3 & 4)) break;
			if(bChoice && other_page == DIGG && !(engineChoice3 & 8)) break;
			FS_extOtherRate(other_page, event.target);
		} while (false);
	}
	/**/
    //var search_page = getSearchIndex(docHref);
	
    var search_page = 0;
	
    // Rex: Check if we need to show link reputation in result page
    if(XX_GetUserPref() != "0" && localInterface.excCommand(1207, null) != 0)
        search_page = getSearchIndex(docHref);

    //dump("serach page " + search_page + "\n");
    if ( search_page != 0 )
    {
        //dump("serach page " + search_page + "\n");
        do
        {
            if(bChoice && search_page == GOOGLE && !(engineChoice1 & 1)) break;
            if(bChoice && search_page == YAHOO && !(engineChoice1 & 2)) break;
            if(bChoice && search_page == LIVE && !(engineChoice1 & 4)) break;
 
            var pageRate = new LinkRateObj();
            pageRate.arLink = docCurrent.links;
            pageRate.id = arrayID;
            linkObjs[arrayID] = pageRate;
            if(FS_ValidLink[search_page])
                pageRate.validLink = FS_ValidLink[search_page];
            pageRate.skipMatch = FS_SkipLink[search_page];
            for(x=0;x<1;x++)
                setTimeout(popPageRate,50,pageRate.id);
				
            stopPageWatch();
            startPageWatch();
        } while ( false);
    }else
    {
        // check if current page is a block page
        //if(!YY_IsBlockURL(localInterface, docHref))
         // return;
        //if(!YY_IsBlockURL(localInterface, docHref))
        //{
        var strBlockPage = XX_GetBlockUrlEx();

        var blockURI = decodeURI(docHref);

        //if(docHref && docHref.indexOf(strBlockPage)==0)
        if(docHref && blockURI.indexOf(strBlockPage)==0)
        {
            // Rex: 17/03/09 - Change toolbar icon to "this site is not analysed icon"
            //XX_UpdateToolbarButton("chrome://litmus-ff/skin/big/lvl0.png", "chrome://litmus-ff/skin/big/lvl0.png", "This site has not been analysed");
            XX_UpdateToolbarButton("chrome://litmus-ff/skin/bp/lvl1.png", "chrome://litmus-ff/skin/bp/lvl1.png", "This site is: SAFE");
        
            g_arrBlockPageLinks = docCurrent.links;
            g_BlockPage = docCurrent;
            setTimeout(XX_DoProcessBlockPage,100, blockURI);
        }
    //}
    }
}

function YY_IsBlockURL(localInterface, strURL)
{
    //strURL = parseURL(strURL);
    
    if(localInterface)
    {
        var szResult = localInterface.getSiteRate(strURL,4);
        var arParam = szResult.split("*");
    
        if(parseInt(parseInt(arParam[3])) == 1 || parseInt(parseInt(arParam[3])) == 2 || parseInt(parseInt(arParam[3])) == 3)
        {
            return openAndReuseOneTabPerURL(localInterface, strURL);
        }
    }

    return false;
}


function openAndReuseOneTabPerURL(localInterface, url)
{
    if(!localInterface)
        return;
    
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
    var browserEnumerator = wm.getEnumerator("navigator:browser");

    // Check each browser instance for our URL
    var found = false;
    while (!found && browserEnumerator.hasMoreElements())
    {
        var browserWin = browserEnumerator.getNext();
        var tabbrowser = browserWin.getBrowser();
      
        // Check each tab of this browser instance
        var numTabs = tabbrowser.browsers.length;
      
        for(var index=0; index<numTabs; index++)
        {
            var currentBrowser = tabbrowser.getBrowserAtIndex(index);
            if (url == currentBrowser.currentURI.spec)
            {
                // The URL is already opened. Select this tab.
                tabbrowser.selectedTab = tabbrowser.mTabs[index];

                // Focus *this* browser-window
                browserWin.focus();
          
                if (url.indexOf("ACTION=CONTINUE")>0)
                {

                    var bSkipAsk = localInterface.excCommand(1111, url );
     					
                    //dump("skipping in ignore list " + bSkipAsk + "\n");
                    if( bSkipAsk != "1")
                    {
                        XX_loadURL(XX_GetBlockUrl(url));
                        g_BlockURL = url;
                    }
  
                    found = true;
                    break;
                }
            }
        }
    }
  
    return found;
}


function XX_DoProcessBlockPage(strCurrentURL)
{
    var cand = g_arrBlockPageLinks[g_BlockPagePosition];
    g_BlockPagePosition++;
    //EndTime = new Date();
    //alert("22");
    if(!cand) {                    
        g_BlockPagePosition = 0;
        g_arrBlockPageLinks = null;
        return;
    }
          
    if(!cand.getAttribute("fsmarker")) {
    
        /*
      if(pluginInterface == null)
      {
      	try {
      		pluginInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
      	}catch (e){
      		dump(e);
      	}
      }
      */
      
        var pluginInterface = null;
        try {
            pluginInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        }catch (e){
            dump(e);
            return;
        }

        // Rex - update block URL in block page
        //g_BlockPage.getElementById('warning-address').innerHTML = g_BlockURL;

    
        if (g_BlockURL != null)
        {
            if(g_BlockURL.length > 50)
            {
                var s = g_BlockURL.substring(0, 47);
                g_BlockURL = s + "...";
            }
   
            var strLabel = pluginInterface.excCommand(1103, "249");
            g_BlockPage.getElementById('warning-header').innerHTML = unescape(strLabel);
            g_BlockPage.getElementById('warning-address').innerHTML = g_BlockURL;
            strLabel = pluginInterface.excCommand(1103, "250");
            g_BlockPage.getElementById('warning-help-link').innerHTML = unescape(strLabel);
            strLabel = pluginInterface.excCommand(1103, "251");
            g_BlockPage.getElementById('message-text').innerHTML = unescape(strLabel);
            strLabel = pluginInterface.excCommand(1103, "252");
            g_BlockPage.getElementById('enter-link').innerHTML = unescape(strLabel);
            strLabel = pluginInterface.excCommand(1103, "253");
            g_BlockPage.getElementById('denied-button').innerHTML = unescape(strLabel);
            strLabel = pluginInterface.excCommand(1103, "254");
            g_BlockPage.getElementById('checkbox-message').innerHTML = unescape(strLabel);
        }
        else
        {
            var strLabel = pluginInterface.excCommand(1103, "256");
            g_BlockPage.getElementById('warning-header').innerHTML = unescape(strLabel);
            strLabel = pluginInterface.excCommand(1103, "999");
            g_BlockPage.getElementById('warning-address').innerHTML = strLabel;
            strLabel = pluginInterface.excCommand(1103, "257");
            g_BlockPage.getElementById('warning-help-link').innerHTML = unescape(strLabel);
            //g_BlockPage.getElementById('enter-message').innerHTML = "";
            strLabel = pluginInterface.excCommand(1103, "279");
            g_BlockPage.getElementById('enter-link').innerHTML = strLabel;
            
            g_BlockPage.getElementById('enter-checkbox').innerHTML = "";
            strLabel = pluginInterface.excCommand(1103, "258");
            g_BlockPage.getElementById('message-text').innerHTML = unescape(strLabel);
            strLabel = pluginInterface.excCommand(1103, "253");
            g_BlockPage.getElementById('denied-button').innerHTML = unescape(strLabel);
        //return;
        }
        
        // admin's trusted site table is final
        if(pluginInterface.excCommand(1222, null) == 1)
        {
          g_BlockPage.getElementById('enter-checkbox').innerHTML = "";
        }
        
        // Allow continue to block page
        if(g_BlockURL != null && pluginInterface.excCommand(1223, null) == 0)
        {
          g_BlockPage.getElementById('enter-message').innerHTML = "";
          g_BlockPage.getElementById('enter-checkbox').innerHTML = "";
        }
            
        var customBanner = pluginInterface.excCommand(1209, null);

        if(customBanner != "")
        {

            g_BlockPage.getElementById('banner').setAttribute("style", unescape(customBanner));
        }

        /*
      var strLabel = pluginInterface.excCommand(1103, "249");
      g_BlockPage.getElementById('warning-header').innerHTML = unescape(strLabel);
      g_BlockPage.getElementById('warning-address').innerHTML = g_BlockURL;
      strLabel = pluginInterface.excCommand(1103, "250");
	    g_BlockPage.getElementById('warning-help-link').innerHTML = unescape(strLabel);
      strLabel = pluginInterface.excCommand(1103, "252");
	    g_BlockPage.getElementById('enter-message').innerHTML = unescape(strLabel);
      strLabel = pluginInterface.excCommand(1103, "251");
  	  g_BlockPage.getElementById('message-text').innerHTML = unescape(strLabel);
      strLabel = pluginInterface.excCommand(1103, "254");
	    g_BlockPage.getElementById('enter-checkbox').innerHTML = unescape(strLabel);
      strLabel = pluginInterface.excCommand(1103, "253");
	    g_BlockPage.getElementById('denied-button').innerHTML = unescape(strLabel);        	  
	  */
	   
          
        //var strURL = cand.href;
        var strURL = decodeURI(cand.href);

        var strBlockPage = XX_GetBlockUrlEx();

        if(strCurrentURL.indexOf(strBlockPage)==0 )
        {
            //alert("33");
            //alert(strURL);
            if(strURL.indexOf("FSSW_HOMEPAGE_LINK")>=0){
          
                var strURL = gHomeButton.getHomePage().split("|")[0];
                var strHomePage = "";
                if(strURL.indexOf("http") < 0)
                {
                    strHomePage = "http://" + strURL;
                } else {
                    strHomePage = strURL;
                }
            
                cand.setAttribute("href", strHomePage);
            
            } else if(strURL.indexOf("FSSW_PORTAL_LINK")>=0){
                var iLastSlashIndex = strCurrentURL.lastIndexOf("/");
                var pageName = strCurrentURL.substring(iLastSlashIndex + 1,strCurrentURL.length);
                var strContinue = pageName + "&ACTION=BPPORTAL";
                cand.setAttribute("href", strContinue);
            } else if(strURL.indexOf("FSSW_CONTINUE_LINK")>=0){
                //alert("44");
                //alert(strCurrentURL.split("?")[1]);s
                //alert(strCurrentURL.split("/")[5]);
                //alert(strCurrentURL.split("/")[1]);
                //alert(strCurrentURL.split("/")[2]);
                //alert(strCurrentURL.split("/")[3]);
                //alert(strCurrentURL.split("/")[4]);
                //alert(strCurrentURL.split("/")[5]);
                 if(g_BlockURL != null)
                 {
                    var iLastSlashIndex = strCurrentURL.lastIndexOf("/");
                    var pageName = strCurrentURL.substring(iLastSlashIndex + 1,strCurrentURL.length);
             
                    //var strContinue = strCurrentURL.split("/")[8] + "&ACTION=CONTINUE";
                    var strContinue = pageName + "&ACTION=CONTINUE";
                    cand.setAttribute("href", strContinue);
                } else
                {
                   var strLabel = pluginInterface.excCommand(1103, "280");
                   strLabel += pluginInterface.excCommand(1103, "999");
                  cand.setAttribute("href", strLabel);
                }
            }else if(strURL.indexOf("FSSW_WHITELIST_LINK")>=0)
            {
                var strWhitelistUrl = strCurrentURL.split("/")[8] + "&ACTION=WHITELIST";
                cand.setAttribute("href", strWhitelistUrl);
            }
        }
    }
      
    setTimeout(XX_DoProcessBlockPage,100,strCurrentURL); 
    return;
}

function PostDOMLoaded(event)
{
  try {
		var localInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
		if(localInterface) {
			
      if(localInterface.excCommand(1114,null) == "1")
      {
        XX_UpdateToolbarButton("chrome://litmus-ff/skin/bp/lvl6.png", "chrome://litmus-ff/skin/pop/lvl6.png", "Browsing Protection has expired");
        return;
      }
    }
  }catch(e)
  {
  }
  
	if(XX_GetUserPref() == "0") return;
	window.content.document.addEventListener("submit", XX_onDOMSubmit, false);
	setTimeout(YY_handleDOMLoaded,1,event.target.location.href,event.target);
	return;  
}

// use to determine PostDOMLoaded() progress
var bInDOMLoadedProc = false;

function XX_TitleChanged(event)
{
    try {
        var localInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        if(localInterface) {
            if(YY_IsBlockURL(localInterface, event.target.location.href))
            {
                return;
            }
        }
    }catch(e)
    {
    }

  // Fixed of ajax refrshing issue on Firefox 2.0   
  if(g_MozillaVersion >= 2 && g_MozillaVersion < 3)
  {
    bInDOMLoadedProc = true;
    PostDOMLoaded(event);
  }
}

function XX_onDOMLoaded(event)
{
  if(bInDOMLoadedProc) {
    bInDOMLoadedProc = false; 
    return;
  }
 
  PostDOMLoaded(event);
/*  try {
		var localInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
		if(localInterface) {
			
            if(localInterface.excCommand(1114,null) == "1")
            {
                XX_UpdateToolbarButton("chrome://litmus-ff/skin/big/lvl6.png", "chrome://litmus-ff/skin/pop/lvl6.png", "Browsing Protection has expired");
                return;
            }
        }
    }catch(e)
    {
    }
*/
  
    /*if(YY_IsBlockURL(localInterface, event.target.location.href))
  {
    return;
  }*/
  
    //if(event.target.location.href == "about:blank") return;
  
    //dump("URL: " + event.target.links.length + "\n");
  
    //var frames = event.target.getElementsByTagName("iframe");
    //dump("found frames: " + frames.length + "\n");
    //for (var i = 0; i < frames.length; i++)
    //{
    //}
  
/*	if(XX_GetUserPref() == "0") return;
	window.content.document.addEventListener("submit", XX_onDOMSubmit, false);
	setTimeout(YY_handleDOMLoaded,1,event.target.location.href,event.target);
*/	return;

    var arrayID = Math.randomMax(65535);
    var bChoice = false;
    var engineChoice1 = 0;
    var engineChoice2 = 0;
    var engineChoice3 = 0;
    try {
        var localInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        if(localInterface) {
            bChoice = true;//!(localInterface.getPreference("SafetyRate","") & 4);
            engineChoice1 = localInterface.getPreference("EngineChoice","0");
            engineChoice2 = localInterface.getPreference("EngineChoice","1");
            engineChoice3 = localInterface.getPreference("EngineChoice","2");
            if(localInterface.getPreference("SafetyRate","") & 2)
            {
                engineChoice1 = -1;
                engineChoice2 = -1;
                engineChoice3 = -1;
            }
        }
    }catch (e){
    //dump(e);
    }
	
    var mail_page = getMailIndex(event.target.location.href);

    if ( mail_page != 0 )
    {
        do
        {
            if(bChoice && mail_page == GOOGLE && !(engineChoice2 & 1)) break;
            if(bChoice && mail_page == YAHOO && !(engineChoice2 & 2)) break;
            if(bChoice && mail_page == HOTMAIL && !(engineChoice2 & 4)) break;
            FS_extMailRate(mail_page, event.target);
        } while (false);
    }
	
    var other_page = 0;
    /*
	var other_page = getOtherIndex(event.target.location.href);
	//dump("other page " + other_page + "\n");
	if ( other_page != 0 )
	{
		do
		{	
			if(bChoice && other_page == WIKI && !(engineChoice3 & 1)) break;
			if(bChoice && other_page == DMOZ && !(engineChoice3 & 2)) break;
			if(bChoice && other_page == DELICIOUS && !(engineChoice3 & 4)) break;
			if(bChoice && other_page == DIGG && !(engineChoice3 & 8)) break;
			FS_extOtherRate(other_page, event.target);
		} while (false);
	}
	/**/
    var search_page = getSearchIndex(event.target.location.href);
    //dump("serach page " + search_page + "\n");
    if ( search_page != 0 )
    {
        do
        {
            if(bChoice && search_page == GOOGLE && !(engineChoice1 & 1)) break;
            if(bChoice && search_page == YAHOO && !(engineChoice1 & 2)) break;
            if(bChoice && search_page == LIVE && !(engineChoice1 & 4)) break;
            var pageRate = new LinkRateObj();
            pageRate.arLink = event.target.links;
            pageRate.id = arrayID;
            linkObjs[arrayID] = pageRate;
            if(FS_ValidLink[search_page])
                pageRate.validLink = FS_ValidLink[search_page];
            pageRate.skipMatch = FS_SkipLink[search_page];
            setTimeout(popPageRate,1,pageRate.id);
            setTimeout(popPageRate,1,pageRate.id);
            setTimeout(popPageRate,1,pageRate.id);
        } while ( false );
    }
}

function XX_startPop(arrayID)
{
    //	dump("Inside async check\n");
    var cand = col[arrayID].cand[col[arrayID].position];
    col[arrayID].position++;
    if(cand /*&& col[arrayID].position<=200*/) {
        if (cand.getElementsByTagName("IMG").length > 0) {
            setTimeout("XX_startPop(" + arrayID + ");",1);
            return;
        }
        var checkLink = parseUrl(FS_ValidLink[col[arrayID].Site](cand));
		
        if (!checkLink || checkLink.match(FS_SkipLink[col[arrayID].Site])) {
            setTimeout("XX_startPop(" + arrayID + ");",1);
            return;
        }
        if(col[arrayID].Site==YAHOO && checkLink.match(/^http:\/\/yahoo\./)) {
            setTimeout("XX_startPop(" + arrayID + ");",1);
            return;
        }
        //		dump("SA checklink " + checkLink + "\n");
        if(checkLink &&	!cand.getAttribute("fsmarker")) {
            cand.setAttribute("fsmarker",arrayID);
            FS_addBubble(cand.ownerDocument);
            var imgRate = cand.ownerDocument.createElement("img");
            imgRate.setAttribute("src", "chrome://litmus-ff/skin/small/load.gif");
            imgRate.setAttribute("id", fsRandomStart);
            imgRate.setAttribute("border", "0");
            //cand.parentNode.insertBefore(imgRate, cand.nextSibling);
            cand.parentNode.insertBefore(imgRate, cand);
            //cand.appendChild(imgRate);
            //fsLitmus.setNodeRate(cand,window.content.document.location);
            ////////////////////////////////////////
            imgRate.setAttribute("fsmarker",""); //put the msg we want to show at here
            imgRate.setAttribute("fslinker",checkLink);
            if(pluginInterface == null)
            {
                try {
                    pluginInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
                }catch (e){
                //dump(e);
                }
            }
            var szResult = pluginInterface.getSiteRate(checkLink,2);
            if( szResult != "" )
            {
                var arParam = szResult.split("*");
                imgRate.setAttribute("src",arParam[0]);
                imgRate.setAttribute("fsmarker",szResult); //put the msg we want to show at here
                if(pluginInterface.getPreference("SafetyRate","") & 2)
                    imgRate.setAttribute("onmouseover","FS_showBubble(event,this)");
                else
                    imgRate.setAttribute("onclick","FS_showBubble(event,this)");
                imgRate.setAttribute("onmousemove","FS_moveBubble(event)");
                if(arParam[2] && (pluginInterface.getPreference("SafetyRate","") & 1))
                {
                    imgRate.nextSibling.setAttribute("style",arParam[2]);
                }
            } else {
                XX_CreateAsyncReq(checkLink,2,imgRate);
            }
        }
        setTimeout("XX_startPop(" + arrayID + ");",1);
    } else
    {
        col[arrayID]=null;
    }
}
////////////////////////////////////////////////////////////////////////////////
//Progress listener code
const ST_START = Components.interfaces.nsIWebProgressListener.STATE_START;
const ST_STOP  = Components.interfaces.nsIWebProgressListener.STATE_STOP;
const ST_IS_WND = Components.interfaces.nsIWebProgressListener.STATE_IS_WINDOW;

const ST_MASK_WND = Components.interfaces.nsIWebProgress.NOTIFY_STATE_WINDOW;
const ST_MASK_STATUS = Components.interfaces.nsIWebProgress.NOTIFY_STATUS;
const ST_MASK_LOCATION = Components.interfaces.nsIWebProgress.NOTIFY_LOCATION;
const ST_MASK_PROGRESS = Components.interfaces.nsIWebProgress.NOTIFY_PROGRESS;

var fsProgressListener = {
    bProgAsking : false,
    bAddressChanged : true,
    QueryInterface : function(aIID)
    {
        //Allow other component to QI this object
        if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
            aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
            aIID.equals(Components.interfaces.nsISupports)
            ) {
            return this;
        }
        throw Components.results.NS_NOINTERFACE;
    },
    //Function that we are not going to implement
    onProgressChange: function(a,b,c,d,e,f)
    {
        //dump("requested : " + a + " requested : " + b + " requested : " + e + " requested : " + f + "\n");
        if(!this.bProgAsking && this.bAddressChanged)
        {
            var szHref = parseUrl(window.content.location);//window.content.document.location.href;
            var sCurrentUrl = parseUrl(window.content.document.location.href);
            if(pluginInterface == null)
            {
                try {
                    pluginInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
                }catch (e){
                //dump(e);
                }
            }
            //if(XX_GetUserPref() == "3" ||
            //window.content.document.location.href.indexOf("http://localhost/")==0 || window.content.document.location.href.indexOf("http://localhost/")==0 || window.content.document.location.href.indexOf("chrome://")==0 || window.content.document.location.href.indexOf("about:")==0 || window.content.document.location.href.indexOf("file://")==0
            //) {
            if(XX_GetUserPref() == "0" ||
                sCurrentUrl.indexOf("chrome://")==0 || sCurrentUrl.indexOf("file://")==0
                ) {
                ///*
                /*if(XX_GetUserPref() != "0")
                {
                    try{
                        document.getElementById('litmus-ff-button').setAttribute("image","chrome://litmus-ff/skin/bp/on.png");
                        document.getElementById('litmus-ff-tooltip-text').setAttribute("value","");
                    }catch(e){}
                }*/
                /**/
                return;
            }
            //dump("Stop navigate " + szHref + "\n");
            var szResult = pluginInterface.getSiteRate(szHref,3);
            //dump(szResult + "\n");
            if( szResult != "" )
            {
                document.getElementById('litmus-ff-tooltip-docloc').setAttribute("value",szHref);
                this.bAddressChanged = false;
                this.updateToolbar(szResult,null,true);
				
            } else {
        /*
				document.getElementById('litmus-ff-button').setAttribute("image","chrome://litmus-ff/skin/big/on.png");
				document.getElementById('litmus-ff-tooltip-text').setAttribute("value",szResult);
				/**/
        }
        }
    },
    onSecurityChange: function(a,b,c) {},
    onStatusChange  : function(a,b,c,d){},
    //Threre is changes in browser's location bar
    onLocationChange: function(aWebProgress,aRequest,aLocation)
    {
        if(pluginInterface == null)
        {
            try {
                pluginInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
            }catch (e){
            //dump(e);
            }
        }
        pluginInterface.excCommand(1113,null);//close current bubble
        this.bAddressChanged = true;
    },
    /*
	{
	  bProgAsking = false;
		//dump("check our site rating now.....loc change\n");
		if(pluginInterface == null)
		{
			try {
				pluginInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
			}catch (e){
				//dump(e);
			}
		}
		if(XX_GetUserPref() == "3" ||
		window.content.document.location.href.indexOf("chrome://")==0 || window.content.document.location.href.indexOf("about:")==0 || window.content.document.location.href.indexOf("file://")==0
		) {
			///*
			if(XX_GetUserPref() != "3")
			{
				document.getElementById('litmus-ff-button').setAttribute("image","chrome://litmus-ff/skin/big/on.png");
				document.getElementById('litmus-ff-tooltip-text').setAttribute("value","");
			}
			/**\/
			return;
		}
		//dump("Loc change request " + aLocation.prePath + aLocation.path + " ee\n");
		//href need preprocess;
		var szHref = window.content.document.location.href;
		if (szHref.match(/^http:\/\/rds.yahoo.com/))
		{
			szHref = szHref.split("/**")[1];
		}
		var szResult = pluginInterface.getSiteRate(szHref,3);
		//var szResult = pluginInterface.getSiteRate(window.content.document.location.href,1);
		if( szResult != "" )
		{
 			document.getElementById('litmus-ff-tooltip-docloc').setAttribute("value",szHref);
			this.updateToolbar(szResult,null,true);
		} else {
			//document.getElementById('litmus-ff-button').setAttribute("image","chrome://litmus-ff/skin/big/on.png");
			//document.getElementById('litmus-ff-tooltip-text').setAttribute("value",szResult);
		}
	},
/**/
    //There is changes on currently viewed DOM document
    onStateChange   : function(aWebProgress, aRequest, aStateFlags, aStatus)
    {
        /* Reset mail watch counter tick to zero in case the page content change.
           The reason for this is to overcome the ajax fetch page which not being notify in DOM loaded function.
        */
        mailWatchCouterTick = 0;
    
        var sCurrentUrl = parseUrl(window.content.document.location.href);
        //dump("Current state = " + window.content.document.location.href + " ST_DOC " + (aStateFlags & ST_IS_WND) + " Status = " + aStatus + "\n");
        var menuCheck = document.getElementById('InstantWhite');
        if( menuCheck )
        {
            menuCheck.setAttribute("disabled","false");
        }
        if(aRequest)
        {
            if(aRequest.name != sCurrentUrl) return;
        }
    
        var strBlockPage = XX_GetBlockUrlEx();
    
        var szBrowseUrlEx = aRequest.name;
        //if(szBrowseUrlEx.indexOf("http://locallhost/1/") <0 && szBrowseUrlEx.indexOf("http://locallhost/2/")<0){
        if((szBrowseUrlEx.indexOf(strBlockPage) < 0 && szBrowseUrlEx.indexOf("ACTION=BPPORTAL")<0) && (szBrowseUrlEx.indexOf(strBlockPage) < 0 && szBrowseUrlEx.indexOf("ACTION=CONTINUE")<0) && (szBrowseUrlEx.indexOf(strBlockPage) < 0 && szBrowseUrlEx.indexOf("ACTION=WHITELIST")<0)){
            if(XX_GetUserPref() == "0" ||
                (aRequest &&
                    (aRequest.name.indexOf("chrome://")==0 || aRequest.name.indexOf("about:")==0 || aRequest.name.indexOf("file://")==0)
                    )) {
                //turn off menu item
                if( menuCheck )
                {
                    menuCheck.setAttribute("disabled","true");
                }
  
                ///*
                /*if(XX_GetUserPref() != "0")
                {
                    try{
                        document.getElementById('litmus-ff-button').setAttribute("image","chrome://litmus-ff/skin/bp/on.png");
                        document.getElementById('litmus-ff-tooltip-text').setAttribute("value","");
                    }catch(e){}
                }*/
                /**/
                return;
            }
        }else
        {
            if(XX_GetUserPref() == "0" ||
                (aRequest &&
                    (aRequest.name.indexOf("chrome://")==0 || aRequest.name.indexOf("about:")==0 || aRequest.name.indexOf("file://")==0)
                    )) {
                //turn off menu item
                if( menuCheck )
                {
                    menuCheck.setAttribute("disabled","true");
                }
  
                ///*
                /*if(XX_GetUserPref() != "0")
                {
                    document.getElementById('litmus-ff-button').setAttribute("image","chrome://litmus-ff/skin/bp/on.png");
                    document.getElementById('litmus-ff-tooltip-text').setAttribute("value","");
                }*/
                /**/
                return;
            }
        }
    
        if((szBrowseUrlEx.indexOf(strBlockPage) < 0 && szBrowseUrlEx.indexOf("ACTION=BPPORTAL")<0) && (szBrowseUrlEx.indexOf(strBlockPage) < 0 && szBrowseUrlEx.indexOf("ACTION=CONTINUE")<0) && (szBrowseUrlEx.indexOf(strBlockPage) < 0 && szBrowseUrlEx.indexOf("ACTION=WHITELIST")<0)){
            if(sCurrentUrl.indexOf("chrome://")==0 || sCurrentUrl.indexOf("about:")==0 || sCurrentUrl.indexOf("file://")==0
                ) {
                //turn off menu item
                if( menuCheck )
                {
                    menuCheck.setAttribute("disabled","true");
                }
                /*if(XX_GetUserPref() != "0")
                {
                    document.getElementById('litmus-ff-button').setAttribute("image","chrome://litmus-ff/skin/bp/on.png");
                    document.getElementById('litmus-ff-tooltip-text').setAttribute("value","");
                    return;
                }*/
            }
        }else
        {
            if(sCurrentUrl.indexOf("chrome://")==0 || sCurrentUrl.indexOf("about:")==0 || sCurrentUrl.indexOf("file://")==0
                ) {
                //turn off menu item
                if( menuCheck )
                {
                    menuCheck.setAttribute("disabled","true");
                }
                /*if(XX_GetUserPref() != "0")
                {
                    document.getElementById('litmus-ff-button').setAttribute("image","chrome://litmus-ff/skin/bp/on.png");
                    document.getElementById('litmus-ff-tooltip-text').setAttribute("value","");
                    return;
                }*/
            }
		
        }
     
        var strBlockPage = XX_GetBlockUrlEx();
        
        //if(window.content.document.location.href.match(/^http:\/\/localhost:6789\//i)
        //) {
        if(sCurrentUrl.indexOf(strBlockPage)==0)
        {
            //turn off menu item
            if( menuCheck )
            {
                menuCheck.setAttribute("disabled","true");
            }
            /*if(XX_GetUserPref() != "0")
            {
                document.getElementById('litmus-ff-button').setAttribute("image","chrome://litmus-ff/skin/bp/on.png");
                document.getElementById('litmus-ff-tooltip-text').setAttribute("value","");
                return;
            }*/
        }
        if(pluginInterface == null)
        {
            try {
                pluginInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
            }catch (e){
            //dump(e);
            }
        }
        //		if(aRequest)
        //  		dump("Request Name " + aRequest.name + " with " + (aStateFlags & ST_START) + "\n");
        if((aStateFlags & ST_IS_WND)) {
			
			
            if(!(aStateFlags & ST_START) && aRequest) {
                var szBrowseUrl = aRequest.name;
                //alert("CCC");
                //alert(szBrowseUrl);
                if(szBrowseUrl.match(/^http:\/\/locallhost\/1\//i))
                //if(szBrowseUrl.indexOf("http://www.f-secure.com/beta/safeweb/safeweb_blocked.html")==0 && szBrowseUrl.indexOf("ACTION=CONTINUE")>=0)
                {
  			
                    pluginInterface.excCommand(1109,szBrowseUrl.split("&")[1]);
                    aRequest.cancel(0x804b0002);
                    XX_loadURL(szBrowseUrl.split("&")[1]);
                    return;
                }
  			
                if(szBrowseUrl.match(/^http:\/\/locallhost\/2\//i))
                //if(szBrowseUrl.indexOf("http://www.f-secure.com/beta/safeweb/safeweb_blocked.html")==0 && szBrowseUrl.indexOf("ACTION=WHITELIST")>=0)
                {
                    pluginInterface.excCommand(1110,szBrowseUrl.split("&")[1]);
                    aRequest.cancel(0x804b0002);
                    XX_loadURL(szBrowseUrl.split("&")[1]);
                    return;
                }
            }
      
            if(!(aStateFlags & ST_START) && (aStatus != 0) && aRequest) {
			  
                try {
                    var currChannel = aRequest.QueryInterface(Components.interfaces.nsIHttpChannel);
                    if(currChannel && currChannel.requestMethod=="POST")
                    {
                        return; // we only trap submit action...
                    }
                } catch (e)
                {
                }
                //dump("Request Name " + aRequest.name + "\n");
                //process our block address;
				
                var szBrowseUrl = aRequest.name;
                /*
				if(szBrowseUrl.match(/^http:\/\/locallhost\/1\//i))
				{
				  pluginInterface.excCommand(1109,szBrowseUrl.split("http://locallhost/1/")[1]);
				  aRequest.cancel(0x804b0002);
				  XX_loadURL(szBrowseUrl.split("http://locallhost/1/")[1]);
				  return;
        }
				if(szBrowseUrl.match(/^http:\/\/locallhost\/2\//i))
				{
				  pluginInterface.excCommand(1110,szBrowseUrl.split("http://locallhost/2/")[1]);
				  aRequest.cancel(0x804b0002);
				  XX_loadURL(szBrowseUrl.split("http://locallhost/2/")[1]);
				  return;
        }
				*/
				
                var szResult = pluginInterface.getSiteRate(parseUrl(aRequest.name),4);
                if( szResult != "" && !this.bProgAsking && this.bAddressChanged)
                {
                    document.getElementById('litmus-ff-tooltip-docloc').setAttribute("value",aRequest.name);
                    this.bAddressChanged = false;
                    this.updateToolbar(szResult,aRequest,true);
                } else {
            /*
					document.getElementById('litmus-ff-button').setAttribute("image","chrome://litmus-ff/skin/big/on.png");
					document.getElementById('litmus-ff-tooltip-text').setAttribute("value",szResult);
					/**/
            }
            }
            if((aStateFlags & ST_STOP) && (aStatus != 0x804b0002)) {
                var szHref = parseUrl(window.content.document.location.href);
                //dump("Stop navigate " + szHref + "\n");
                var szResult = pluginInterface.getSiteRate(szHref,4);
                //dump(szResult + "\n");
                if( szResult != "" && !this.bProgAsking)
                {
                    document.getElementById('litmus-ff-tooltip-docloc').setAttribute("value",szHref);
                    this.updateToolbar(szResult,null,true);
                } else {
            /*
					document.getElementById('litmus-ff-button').setAttribute("image","chrome://litmus-ff/skin/big/on.png");
					document.getElementById('litmus-ff-tooltip-text').setAttribute("value",szResult);
					/**/
            }
            }
        }
    },
    updateToolbar : function(szResult, aRequest, bAsk)
    {
        var sCurrentUrl = parseUrl(window.content.document.location.href);
        if(this.bProgAsking) return;
        this.bProgAsking = true;

        var arParam = szResult.split("*");
		
        XX_UpdateToolbarButton(arParam[0].replace(/(small)/gi,"bp"), arParam[0].replace(/(small)/gi,"pop"), szResult);

        var szSite = "";
        var szAskSite = "";
		
        //alert("4");
        if(aRequest)
        {
            szSite = aRequest.name.split("://")[1]?aRequest.name.split("/")[2].split("?")[0]:aRequest.name.split("/")[0].split("?")[0];
            szAskSite = aRequest.name;
        }
        else
        {
            szSite = sCurrentUrl.split("://")[1]?sCurrentUrl.split("/")[2].split("?")[0]:sCurrentUrl.split("/")[0].split("?")[0];
            szAskSite = sCurrentUrl;
        }
		
        if(!bAsk) {
            this.bProgAsking = false;
            return;
        }		///*
		
        //alert("5");
        if(arParam[3] && bAsk)
        {
            if(parseInt(arParam[3])<4 && parseInt(arParam[3])>=0)
            {
                var strBlockPage = XX_GetBlockUrlEx();
			  
                if((szAskSite.indexOf(strBlockPage) < 0 && szAskSite.indexOf("ACTION=BPPORTAL")<0) && (szAskSite.indexOf(strBlockPage) < 0 && szAskSite.indexOf("ACTION=CONTINUE")<0)&& (szAskSite.indexOf(strBlockPage)<0 && szAskSite.indexOf("ACTION=WHITELIST")<0)&& szAskSite.indexOf(strBlockPage) <0 && szAskSite.indexOf("about:blank") <0){
  				
                    if(parseInt(parseInt(arParam[3])) == 1 && XX_GetUserOption(1)&1)
                    {
                        var bSkipAsk = pluginInterface.excCommand(1111, szAskSite );
                        //alert('rex-1');
   					
                        //dump("skipping in ignore list " + bSkipAsk + "\n");
                        if( bSkipAsk != "1")
                        {
                            if(aRequest) aRequest.cancel(0x804b0002);
                            g_BlockURL = szAskSite;
                            XX_loadURL(XX_GetBlockUrl(szAskSite));
                        //alert(g_BlockURL);
                        }
                    }
  				
                    if(parseInt(parseInt(arParam[3])) == 1 && XX_GetUserOption(1)&2)
                    {
  				
                        g_OnProgressResult = szResult;
                        g_OnProgressRequest = aRequest;
    					
    				
                        setTimeout("XX_StopBrowser();",1, g_OnProgressResult, g_OnProgressRequest);
              
                    }

                    if(parseInt(parseInt(arParam[3])) == 0 && XX_GetUserOption(3)&2)
                    {
  				
                        g_OnProgressResult = szResult;
                        g_OnProgressRequest = aRequest;
    					
    					
                        setTimeout("XX_StopBrowser();",1, g_OnProgressResult, g_OnProgressRequest);
              
                    }
  				
                    if(parseInt(parseInt(arParam[3])) == 0 && XX_GetUserOption(3)&1)
                    {
  				
                        var bSkipAsk = pluginInterface.excCommand(1111, szAskSite );
  		 				
                        //dump("skipping in ignore list " + bSkipAsk + "\n");
                        if( bSkipAsk != "1")
                        {
                            if(aRequest) aRequest.cancel(0x804b0002);
                            XX_loadURL(XX_GetBlockUrl(szAskSite));
                            g_BlockURL = szAskSite;
                        }
                    }
				
				
                    if(parseInt(parseInt(arParam[3])) == 2 && XX_GetUserOption(1)&1)
                    {
                        var bSkipAsk = pluginInterface.excCommand(1111, szAskSite );
   					
                        //dump("skipping in ignore list " + bSkipAsk + "\n");
                        if( bSkipAsk != "1")
                        {
                            if(aRequest) aRequest.cancel(0x804b0002);
                            XX_loadURL(XX_GetBlockUrl(szAskSite));
                            g_BlockURL = szAskSite;
                        }
                    }
                    if(parseInt(parseInt(arParam[3])) == 2 && XX_GetUserOption(1)&2)
                    {
                        //var szMsg = szSite + " was detected as " + arParam[1] + " site.\r\nDo you want to continue navigate?"
                        //var answer = confirm(szMsg);
                        //if(!answer)
  				
                        g_OnProgressResult = szResult;
                        g_OnProgressRequest = aRequest;
    				
    			
                        setTimeout("XX_StopBrowser();",1, g_OnProgressResult, g_OnProgressRequest);
             
                    /*elvinlee 0505
  					var bSkipAsk = pluginInterface.excCommand(1111, szAskSite );
  					var answer = "";
  					if(bSkipAsk != "1")
              answer = pluginInterface.excCommand(1107, szSite + "*" + arParam[1]  + "*" + arParam[3]);
  					//dump("skipping in ignore list" + bSkipAsk + "\n");
  					if(answer != "")
  					{
  						document.getElementById('litmus-ff-button').setAttribute("image",arParam[0].replace(/(small)/gi,"big"));
  						if(aRequest) aRequest.cancel(0x804b0002);
  						XX_loadURL(XX_GetBlockUrl());

						// Rex: BP Gui integration
						document.getElementById('FS-Rating-Button').setAttribute("image",arParam[0].replace(/(small)/gi,"bp"));

  					}
  					*/
                    }
  				
                    if(parseInt(parseInt(arParam[3])) == 3 && XX_GetUserOption(2)&1)
                    {
                        var bSkipAsk = pluginInterface.excCommand(1111, szAskSite );

                        //dump("skipping in ignore list " + bSkipAsk + "\n");
                        if( bSkipAsk != "1")
                        {
                            if(aRequest) aRequest.cancel(0x804b0002);
                            XX_loadURL(XX_GetBlockUrl(szAskSite));
                            g_BlockURL = szAskSite;
                        }
                    }
                    if(parseInt(parseInt(arParam[3])) == 3 && XX_GetUserOption(2)&2)
                    {
  				
                        g_OnProgressResult = szResult;
                        g_OnProgressRequest = aRequest;
    				
    				
                        setTimeout("XX_StopBrowser();",1, g_OnProgressResult, g_OnProgressRequest);
             
                    }
                }
            /*
				if(XX_GetUserPref() == "1") {
					if(aRequest) aRequest.cancel(0x804b0002);
					XX_loadURL(XX_GetBlockUrl());
				}
				if(XX_GetUserPref() == "2") {
					var szSite = "";
					if(aRequest)
						szSite = aRequest.name.split("://")[1]?aRequest.name.split("/")[2].split("?")[0]:aRequest.name.split("/")[0].split("?")[0];
					else
						szSite = window.content.document.location.href.split("://")[1]?window.content.document.location.href.split("/")[2].split("?")[0]:window.content.document.location.href.split("/")[0].split("?")[0];
					var szMsg = szSite + " was detected as " + arParam[1] + " site.\r\nDo you want to continue navigate?"
					var answer = confirm(szMsg);
					if(!answer)
					{
						if(aRequest) aRequest.cancel(0x804b0002);
						document.getElementById('litmus-ff-button').setAttribute("image",arParam[0].replace(/(small)/gi,"big"));
						XX_loadURL(XX_GetBlockUrl());

						// Rex: BP Gui integration
						document.getElementById('FS-Rating-Button').setAttribute("image",arParam[0].replace(/(small)/gi,"bp"));

					}
				}
				/**/
				
            }
        }
        /**/
        this.bProgAsking = false;
    }
}

////////////////////////////////////////////////////////////////////////////////
//ISkeletonCallback in JS
var fsISkeletonCallback = {
    QueryInterface : function(aIID)
    {
        //Allow other component to QI this object
        if (aIID.equals(Components.interfaces.ISkeletonCallback) ||
            aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
            aIID.equals(Components.interfaces.nsISupports)
            ) {
            return this;
        }
        throw Components.results.NS_NOINTERFACE;
    },
    onServerReady : function(szUrl)
    {
        //dump("Received " + szUrl + "\n");
        return "Compiled";
    },
    onServerQuery : function(szUrl, nType)
    {
    //dump("starting async request now..... time it for toolbar\n");
    //setTimeout(XX_CreateAsyncReq, 20, szUrl, nType, null);
    }
}

function XX_CreateAsyncReq(link, type, node)
{
    link = parseUrl(link);
    var sCurrentUrl = parseUrl(window.content.document.location.href);
    if(pluginInterface == null)
    {
        try {
            pluginInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        }catch (e){
        //dump(e);
        }
    }
    var szResult = pluginInterface.setSiteRate(type,link);
    //	dump("async call result: " + szResult + "\n");
    if (szResult != "")
    {
        //update what every we need - node or toolbar
        if (type == 1)
        {
            //update toolbar
            if(sCurrentUrl != link) return;
            var arParam = szResult.split("*");
            document.getElementById('litmus-ff-button').setAttribute("image",arParam[0].replace(/(small)/gi,"bp"));
            document.getElementById("xxImg").setAttribute("src",arParam[0].replace(/(small)/gi,"pop"));
            //document.getElementById('litmus-ff-tooltip-text').setAttribute("value",szResult);
            //document.getElementById('litmus-ff-tooltip-docloc').setAttribute("value",req.linkreq);

            // Rex: BP Gui integration
            document.getElementById('FS-Rating-Button').setAttribute("image",arParam[0].replace(/(small)/gi,"bp"));

            ///*
            if(arParam[3])
            {
                if(parseInt(arParam[3])<3 && parseInt(arParam[3])>0)
                {
                    if(XX_GetUserPref() == "1") {
                        XX_loadURL(XX_GetBlockUrl(sCurrentUrl));
                    }
                    if(XX_GetUserPref() == "2") {
                        var szSite = sCurrentUrl.split("://")[1]?sCurrentUrl.split("/")[2].split("?")[0]:sCurrentUrl.split("/")[0].split("?")[0];
                        //var szMsg = szSite + " was detected as " + arParam[1] + " site.\r\nDo you want to continue navigate?"
                        //var answer = confirm(szMsg);
                        //if(!answer)
                        var answer = pluginInterface.excCommand(1107, szSite + "*" + arParam[1]  + "*" + arParam[3]);
                        if(answer == "cancel")
                        {
                            document.getElementById('litmus-ff-button').setAttribute("image",arParam[0].replace(/(small)/gi,"bp"));
                            XX_loadURL(XX_GetBlockUrl(sCurrentUrl));

                            // Rex: BP Gui integration
                            document.getElementById('FS-Rating-Button').setAttribute("image",arParam[0].replace(/(small)/gi,"bp"));

                        }
                    }
                }
            }
        }
    
        if (type == 2)
        {

            //update img node
            var arParam = szResult.split("*");


            if(node)
            {
                node.setAttribute("src",arParam[0]);
                node.setAttribute("fsmarker",szResult); //put the msg we want to show at here
                node.href = link;
				
                var bShow = pluginInterface.excCommand(1118, 0);
                if(bShow=="0"){
                    if(arParam[3]==0)
                        node.style.display = "none";
                }
				  
                //if(pluginInterface.getPreference("SafetyRate","") & 4)
                node.addEventListener ("mouseover", fsEventListner, false);
                //else
                node.addEventListener ("click", fsEventListner, false);
				
				
                //dump("we are inside update node " + req.reqnode + " $$ " + szResult + "\n");
                if(arParam[2] && parseInt(arParam[3])>0 &&  (pluginInterface.getPreference("SafetyRate","") & 1))
                {
                    //node.previousSibling.setAttribute("style",arParam[2]);
                    node.nextSibling.setAttribute("style",arParam[2]);
                }
            }
        }
    
    /*
    if (type == 3) {
    	//update our tiny pop
    	var popElement = document.getElementById("lite-bubble");
    	//dump("anchored " + popElement.achLink + "\nResponded " + req.linkreq + "\n");
    	if(popElement.achLink == link) {
    	if(XXGenericCop._showtimer) clearTimeout(XXGenericCop._showTimer);
    		var arParam = szResult.split("*");
     		document.getElementById("litmus-ff-popinfo").hidePopup();
     		var aX = popElement.showX;
     		var aY = popElement.showY;
        document.getElementById("lite-bubble").hidePopup();
        
    		popElement = document.getElementById("xxImg");
    		popElement.setAttribute("src",arParam[0].replace(/(small)/gi,"pop"));
    		popElement = document.getElementById("xxRate");
    		popElement.value = "This webpage is " + FS_GetRate(szResult);
    		popElement = document.getElementById("xxDetail");
    		popElement.firstChild.nodeValue = FS_GetDetailDesc(szResult);
    
    		popElement = document.getElementById("xxSite");
    		popElement.value = link.split("://")[1]?link.split("/")[2].split("?")[0]:link.split("/")[0].split("?")[0];
    		popElement = document.getElementById("xxCat");
    		popElement.value = arParam[1];
    		document.popupNode = null;
    		document.getElementById("litmus-ff-popinfo").showPopup(document.documentElement, aX+15, aY+20, "tooltip",null,null);
    		XXGenericCop._showTimer = setTimeout(XXGenericCop.ClosePop, 5000);
    	}
    }
		*/			
    } else {
        if(type != 1)
        {
            setTimeout(XX_CreateAsyncReq,500,link,type,node);
        } /*else {
            document.getElementById('litmus-ff-button').setAttribute("image","chrome://litmus-ff/skin/bp/on.png");
            document.getElementById('litmus-ff-tooltip-text').setAttribute("value",szResult);
        }*/
    }
}
////////////////////////////////////////////////////////////////////////////////
//JS XMLHttpRequest
function XX_CreateAsyncReq2(link, type, node)
{
    var req = new XMLHttpRequest();
    var reqUrl = "http://10.70.0.78:8080/nrs-lookup/lookup?url=" + link;
    //dump("requesting " + link + "\n");
    req.open("GET",reqUrl,true);
    req.linkreq = link;
    req.reqtype = type;
    if(node)
        req.reqnode = node;
    req.onreadystatechange = function () {
        if (req.readyState == 4) {
            var stat;
            try {
                //dump("ReQ = " + req + "\n");
                stat = req.status;
            }
            catch(staterr) {
                //dump("staterr is " + staterr + "\n");
                stat = 500;
            }
            //dump("packet reply stat = " + stat + "\n");
            // http reply 200 == OK
            if (stat == 200) {
                if(pluginInterface == null)
                {
                    try {
                        pluginInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
                    }catch (e){
                    //dump(e);
                    }
                }
                var szResult = pluginInterface.setSiteRate(req.responseText,req.linkreq);
                if (szResult != "")
                {
                    //update what every we need - node or toolbar
                    if (req.reqtype == 1)
                    {
                        //dump("Async Lis " + szResult + "\n");
                        //update toolbar
                        if(window.content.document.location.href != req.linkreq) return;
                        var arParam = szResult.split("*");
                        document.getElementById('litmus-ff-button').setAttribute("image",arParam[0].replace(/(small)/gi,"bp"));
                        document.getElementById("xxImg").setAttribute("src",arParam[0].replace(/(small)/gi,"pop"));
                        //document.getElementById('litmus-ff-tooltip-text').setAttribute("value",szResult);
                        //document.getElementById('litmus-ff-tooltip-docloc').setAttribute("value",req.linkreq);

                        // Rex: BP Gui integration
                        document.getElementById('FS-Rating-Button').setAttribute("image",arParam[0].replace(/(small)/gi,"bp"));

                        ///*
                        if(arParam[3])
                        {
                            if(parseInt(arParam[3])<3 && parseInt(arParam[3])>0)
                            {
                                if(XX_GetUserPref() == "1") {
                                    XX_loadURL(XX_GetBlockUrl(window.content.document.location.href));
                                }
                                if(XX_GetUserPref() == "2") {
                                    var szSite = window.content.document.location.href.split("://")[1]?window.content.document.location.href.split("/")[2].split("?")[0]:window.content.document.location.href.split("/")[0].split("?")[0];
                                    //var szMsg = szSite + " was detected as " + arParam[1] + " site.\r\nDo you want to continue navigate?"
                                    //var answer = confirm(szMsg);
                                    //if(!answer)
                                    var answer = pluginInterface.excCommand(1107, szSite + "*" + arParam[1]  + "*" + arParam[3]);
                                    if(answer == "cancel")
                                    {
                                        document.getElementById('litmus-ff-button').setAttribute("image",arParam[0].replace(/(small)/gi,"bp"));
                                        XX_loadURL(XX_GetBlockUrl(window.content.document.location.href));

                                        // Rex: BP Gui integration
                                        document.getElementById('FS-Rating-Button').setAttribute("image",arParam[0].replace(/(small)/gi,"bp"));

                                    }
                                }
                            }
                        }
                    }
                    if (req.reqtype == 2)
                    {
                        //update img node
                        var arParam = szResult.split("*");
                        if(req.reqnode)
                        {
                            req.reqnode.setAttribute("src",arParam[0]);
                            req.reqnode.setAttribute("fsmarker",szResult); //put the msg we want to show at here
                            req.reqnode.setAttribute("href",req.reqlink);
                            req.reqnode.href = req.reqlink;
                            if(pluginInterface.getPreference("SafetyRate","") & 2)
                            {}//req.reqnode.setAttribute("onmouseover","FS_showBubble(event,this)");
                            else
                            {}//req.reqnode.setAttribute("onclick","FS_showBubble(event,this)");
                            //req.reqnode.setAttribute("onmousemove","FS_moveBubble(event)");
                            //dump("we are inside update node " + req.reqnode + " $$ " + szResult + "\n");
                            if(arParam[2] && parseInt(arParam[3])>0 &&  (pluginInterface.getPreference("SafetyRate","") & 1))
                            {
                                //if(req.reqnode.getAttribute("showhigh") == "true")
                                req.reqnode.nextSibling.setAttribute("style",arParam[2]);
                            //else
                            //	req.reqnode.previousSibling.setAttribute("style",arParam[2]);
                            //req.reqnode.nextSibling.setAttribute("litmus","lvl2");
                            }
                        }
                    }
                    if (req.reqtype == 3) {
                        //update our tiny pop
                        var popElement = document.getElementById("lite-bubble");
                        //dump("anchored " + popElement.achLink + "\nResponded " + req.linkreq + "\n");
                        if(popElement.achLink == req.linkreq) {
                            if(XXGenericCop._showtimer) clearTimeout(XXGenericCop._showTimer);
                            /*
							popElement = document.getElementById("lite-status");
							var arParam = szResult.split("*");
							popElement.setAttribute("src",arParam[0].replace(/(small)/gi,"pop"));
							popElement = document.getElementById("lite-respond");
							popElement.value = "This webpage is " + FS_GetRate(szResult);
						*/
                            var arParam = szResult.split("*");
                            document.getElementById("litmus-ff-popinfo").hidePopup();
                            var aX = popElement.showX;
                            var aY = popElement.showY;
                            document.getElementById("lite-bubble").hidePopup();
  			      
                            popElement = document.getElementById("xxImg");
                            popElement.setAttribute("src",arParam[0].replace(/(small)/gi,"pop"));
                            popElement = document.getElementById("xxRate");
                            popElement.value = "This webpage is " + FS_GetRate(szResult);
                            popElement = document.getElementById("xxDetail");
                            popElement.firstChild.nodeValue = FS_GetDetailDesc(szResult);
				
                            popElement = document.getElementById("xxSite");
                            popElement.value = req.linkreq.split("://")[1]?req.linkreq.split("/")[2].split("?")[0]:req.linkreq.split("/")[0].split("?")[0];
                            popElement = document.getElementById("xxCat");
                            popElement.value = arParam[1];
                            document.popupNode = null;
                            document.getElementById("litmus-ff-popinfo").showPopup(document.documentElement, aX+15, aY+20, "tooltip",null,null);
                            XXGenericCop._showTimer = setTimeout(XXGenericCop.ClosePop, 5000);
                        }
                    }
                } /*else {
                    document.getElementById('litmus-ff-button').setAttribute("image","chrome://litmus-ff/skin/bp/on.png");
                    document.getElementById('litmus-ff-tooltip-text').setAttribute("value",szResult);
                }*/
            } //stat == 200
        } //readyState==4
    };
    req.send(null);
}

function FS_DoCommand(nCommand)
{
    var litmusObj = null;
    try {
        litmusObj = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
    }catch (e){
    //dump(e);
    }
	
    if(nCommand == 1009){
        //make sure Litmus is always visible
        if(litmusObj.excCommand(1114,null) == "1")
        {
            return true;
        }
    }
    //make sure Litmus is always visible
    litmusObj.doCommand(nCommand,null);
//document.getElementById("domainText").value=window.arguments[0];
}

function FS_ExcCommand(nCommand)
{
    var litmusObj = null;
    try {
        litmusObj = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
    }catch (e){
    //dump(e);
    }
	
    //make sure Litmus is always visible
    litmusObj.excCommand(nCommand,parseUrl(window.content.document.location.href));
//document.getElementById("domainText").value=window.arguments[0];
}

function FS_AddWhiteList()
{

    var litmusObj = null;
    try {
        litmusObj = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
    }catch (e){
    //dump(e);
    }
		
    //make sure Litmus is always visible
    if(litmusObj.excCommand(1114,null) == "1")
    {
        return true;
    }
  
    if(XX_GetUserPref() == "0")
    {
        return true;
    }
	
    //make sure Litmus is always visible
    if(litmusObj.excCommand(1112,parseUrl(window.content.document.location.href)) == "yes")
    {
        document.getElementById('litmus-ff-button').setAttribute('image','chrome://litmus-ff/skin/bp/lvl1.png');
    
        // Rex: BP Gui integration
        document.getElementById('FS-Rating-Button').setAttribute('image', 'chrome://litmus-ff/skin/bp/lvl1.png');
    }
}

// Rex: Gui integration
function XX_OnPopupMenuShownRate()
{
    var litmusObj = null;
    try {
        litmusObj = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
    }catch (e){
    //dump(e);
    }
	
    if(litmusObj)
    {
        var strLabel = litmusObj.excCommand(1103, "227");
        document.getElementById("rating-popup-summary").setAttribute("label", unescape(strLabel));
        document.getElementById("ff-popup-summary").setAttribute("label", unescape(strLabel));
        strLabel = litmusObj.excCommand(1103, "243");
        document.getElementById("ff-popup-report").setAttribute("label", unescape(strLabel));        
        strLabel = litmusObj.excCommand(1103, "168");
        document.getElementById("rating-popup-setting").setAttribute("label", unescape(strLabel));
        document.getElementById("ff-popup-setting").setAttribute("label", unescape(strLabel));
    }
}

function XX_OnPopupParentalControl()
{
    var litmusObj = null;
    try {
        litmusObj = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
    }catch (e){
    //dump(e);
    }
	
    if(litmusObj)
    {
        var strLabel = "";
    
        if(litmusObj.excCommand(1224,0) == 1) {    
          strLabel = litmusObj.excCommand(1103, "266");
          document.getElementById("Parental-popup-parent").setAttribute("label", unescape(strLabel));
          document.getElementById("pc-popup-parent").setAttribute("label", unescape(strLabel));
          document.getElementById("Parental-popup-parent").setAttribute("hidden", false);
          document.getElementById("pc-popup-parent").setAttribute("hidden", false);
        } else {
          document.getElementById("Parental-popup-parent").setAttribute("hidden", true);
          document.getElementById("pc-popup-parent").setAttribute("hidden", true);
        }
                
        if(litmusObj.excCommand(1224,1) == 1) {    
          strLabel = litmusObj.excCommand(1103, "267");
          document.getElementById("Parental-popup-teenager").setAttribute("label", unescape(strLabel));
          document.getElementById("pc-popup-teenager").setAttribute("label", unescape(strLabel));
          document.getElementById("Parental-popup-teenager").setAttribute("hidden", false);
          document.getElementById("pc-popup-teenager").setAttribute("hidden", false);          
        } else {
          document.getElementById("Parental-popup-teenager").setAttribute("hidden", true);
          document.getElementById("pc-popup-teenager").setAttribute("hidden", true);
        }
        
        if(litmusObj.excCommand(1224,2) == 1) {            
          strLabel = litmusObj.excCommand(1103, "268");
          document.getElementById("Parental-popup-child").setAttribute("label", unescape(strLabel)); 
          document.getElementById("pc-popup-child").setAttribute("label", unescape(strLabel));
          document.getElementById("Parental-popup-child").setAttribute("hidden", false);
          document.getElementById("pc-popup-child").setAttribute("hidden", false);           
        } else {
          document.getElementById("Parental-popup-child").setAttribute("hidden", true);
          document.getElementById("pc-popup-child").setAttribute("hidden", true);        
        }
        
        strLabel = litmusObj.excCommand(1103, "168");
        document.getElementById("Parental-popup-setting").setAttribute("label", unescape(strLabel));
        document.getElementById("pc-popup-setting").setAttribute("label", unescape(strLabel));
        
        var iProfile = litmusObj.excCommand(1214,null);
        switch(iProfile)
        {
          case "0":
            document.getElementById('Parental-popup-parent').setAttribute("checked", "true");
            document.getElementById('pc-popup-parent').setAttribute("checked", "true");
            document.getElementById('Parental-popup-teenager').setAttribute("checked", "false");
            document.getElementById('pc-popup-teenager').setAttribute("checked", "false");
            document.getElementById('Parental-popup-child').setAttribute("checked", "false");
            document.getElementById('pc-popup-child').setAttribute("checked", "false");
            break;
          case "1": 
            document.getElementById('Parental-popup-parent').setAttribute("checked", "false");
            document.getElementById('pc-popup-parent').setAttribute("checked", "false");
            document.getElementById('Parental-popup-teenager').setAttribute("checked", "true");
            document.getElementById('pc-popup-teenager').setAttribute("checked", "true");
            document.getElementById('Parental-popup-child').setAttribute("checked", "false");
            document.getElementById('pc-popup-child').setAttribute("checked", "false");
            break;
          default:  
            document.getElementById('Parental-popup-parent').setAttribute("checked", "false");
            document.getElementById('pc-popup-parent').setAttribute("checked", "false");
            document.getElementById('Parental-popup-teenager').setAttribute("checked", "false");
            document.getElementById('pc-popup-teenager').setAttribute("checked", "false");
            document.getElementById('Parental-popup-child').setAttribute("checked", "true");
            document.getElementById('pc-popup-child').setAttribute("checked", "true");
            break;
         }        
    }
    
    
}

// Andrew Leong - Ensure Main Menu's label are always displayed as empty in the toolbar
function XX_HideMainMenuLabel()
{
    var litmusObj = null;
    try
    {
        litmusObj = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
    }
    catch (e)
    {
    //dump(e);
    }
	
    if (litmusObj)
    {
        strLabel = "";
        document.getElementById("FS-MainMenu").setAttribute("label", unescape(strLabel));
    }
}
		
function XX_OnPopupFSMainMenuShown()
{
    var litmusObj = null;
    try {
        litmusObj = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
    }catch (e){
    //dump(e);
    }
	
    if(litmusObj)
    {
        var strLabel = "";
        var strMinOrMax = "";
        
        if(XX_GetMinimizeToolbarPref() != "0")
        {
          strMinOrMax = litmusObj.excCommand(1103,255);
        }
        else
        {
          strMinOrMax = litmusObj.excCommand(1103,245);
        }        

        // main menu
        if(XX_GetUserPref() == "0")
        {
            document.getElementById('fs-popup-separator').setAttribute("hidden", false);
            document.getElementById('main-popup-separator').setAttribute("hidden", false);
            document.getElementById('main-popup-turnon').setAttribute("hidden", false);
            document.getElementById('fs-popup-turnon').setAttribute("hidden", false);
	     
            var strLabel = litmusObj.excCommand(1103,248);
            document.getElementById('main-popup-turnon').setAttribute("label", unescape(strLabel));
            document.getElementById('fs-popup-turnon').setAttribute("label", unescape(strLabel));
            document.getElementById('main-popup-minimize').setAttribute("label", unescape(strMinOrMax));
            document.getElementById('fs-popup-minimize').setAttribute("label", unescape(strMinOrMax));            
        }
        else
        {
            document.getElementById('fs-popup-separator').setAttribute("hidden", true);
            document.getElementById('main-popup-separator').setAttribute("hidden", true);
            document.getElementById('main-popup-minimize').setAttribute("label", unescape(strMinOrMax));
            document.getElementById('fs-popup-minimize').setAttribute("label", unescape(strMinOrMax));
            document.getElementById('main-popup-turnon').setAttribute("hidden", true);
            document.getElementById('fs-popup-turnon').setAttribute("hidden", true);
        }
        
        
  /*      	if(!g_OnFspcLoaded || XX_GetFspcPref() == "0")
	{
	 document.getElementById('FS-Parental-Button').setAttribute("hidden",true);
	 document.getElementById('litmus-pc-button').setAttribute("hidden",true);
	 document.getElementById('main-popup-turnon_fspc').setAttribute("hidden",true);
  }*/
        
        if(g_OnFspcLoaded && XX_GetFspcPref() == 0 && XX_GetPSC9_1_Pref() == "1")
        {
          var strLabel = litmusObj.excCommand(1103,270);
          document.getElementById('main-popup-turnon_fspc').setAttribute("hidden", false);
          document.getElementById('fs-popup-turnon_fspc').setAttribute("hidden", false);
          document.getElementById('main-popup-turnon_fspc').setAttribute("label", unescape(strLabel));
          document.getElementById('fs-popup-turnon_fspc').setAttribute("label", unescape(strLabel));           
        }
        else
        {
          document.getElementById('main-popup-turnon_fspc').setAttribute("hidden", true);
          document.getElementById('fs-popup-turnon_fspc').setAttribute("hidden", true);
        }
    }
}

function XX_OnPopupMenuShown()
{

    var litmusObj = null;
    try {
        litmusObj = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
    }catch (e){
    //dump(e);
    }
	
    if(litmusObj)
    {
	   
        var strLabel = litmusObj.excCommand(1103, "174");
        var menuitem = document.getElementById("InstantWhite");
        menuitem.setAttribute("label", unescape(strLabel));
    
        strLabel = litmusObj.excCommand(1103, "163");
        menuitem = document.getElementById("Watch-Block");
        menuitem.setAttribute("label", unescape(strLabel));
    
        strLabel = litmusObj.excCommand(1103, "165");
        menuitem = document.getElementById("Watch-Off");
        menuitem.setAttribute("label", unescape(strLabel));
    
        strLabel = litmusObj.excCommand(1103, "168");
        menuitem = document.getElementById("Setting");
        menuitem.setAttribute("label", unescape(strLabel));
    
        strLabel = litmusObj.excCommand(1103, "164");
        menuitem = document.getElementById("Watch");
        menuitem.setAttribute("label", unescape(strLabel));
    
        strLabel = litmusObj.excCommand(1103, "175");
        menuitem = document.getElementById("About");
        menuitem.setAttribute("label", unescape(strLabel));
    
        strLabel = litmusObj.excCommand(1103, "177");
        menuitem = document.getElementById("PF");
        menuitem.setAttribute("label", unescape(strLabel));
    }
	
    //make sure Litmus is always visible
    if(litmusObj.excCommand(1114,null) == "1")
    {
        var menuitem = document.getElementById("InstantWhite");
        menuitem.setAttribute("disabled", true);
    
        menuitem = document.getElementById("Watch-Block");
        menuitem.setAttribute("disabled", true);
    
        menuitem = document.getElementById("Watch-Off");
        menuitem.setAttribute("disabled", true);
    
        menuitem = document.getElementById("Setting");
        menuitem.setAttribute("disabled", true);
    
        menuitem = document.getElementById("Watch");
        menuitem.setAttribute("disabled", true);
    
    }else
    {
  
        var menuitem = document.getElementById("InstantWhite");
        menuitem.setAttribute("disabled", false);
    
        menuitem = document.getElementById("Watch-Block");
        menuitem.setAttribute("disabled", false);
    
        menuitem = document.getElementById("Watch-Off");
        menuitem.setAttribute("disabled", false);
    
        menuitem = document.getElementById("Setting");
        menuitem.setAttribute("disabled", false);
    
        menuitem = document.getElementById("Watch");
        menuitem.setAttribute("disabled", false);
    
        if(XX_GetUserPref() == "0")
        {
            menuitem = document.getElementById("Watch-Block");
            menuitem.setAttribute("checked", false);
      
            menuitem = document.getElementById("Watch-Off");
            menuitem.setAttribute("checked", true);
      
            menuitem = document.getElementById("InstantWhite");
            menuitem.setAttribute("disabled", true);
       
        }else
        {
            var menuitem = document.getElementById("Watch-Block");
            menuitem.setAttribute("checked", true);
      
            menuitem = document.getElementById("Watch-Off");
            menuitem.setAttribute("checked", false);
    
        }
    
    }
   
}

function XX_Log(strlog)
{

    var litmusObj = null;
    try {
        litmusObj = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
    }catch (e){
    //dump(e);
    }
	
    if(litmusObj != null){
    	 
        var answer = litmusObj.excCommand(1115, strlog);
        if(answer == "0")
        {
            setTimeout(popPageRate,1,this.id);
            return;
        }
    }
	
}

function XX_StopBrowserEx(strCurrentUrl)
{
    window.stop();
    XX_loadURL(XX_GetBlockUrl(strCurrentUrl));
}

function XX_StopAndLoadUrl(szUrl)
{
    window.stop();
    try {
        var localInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        if(localInterface){
            var strTemp = localInterface.excCommand(1203,szUrl);
            XX_loadURL(strTemp);
            NotifyPolicyManager(strTemp, true);//send alert to PM, user continue to blocked page
        }
    }catch (e){
    //dump(e);
    }
}

function XX_StopAndShowPortal(szUrl)
{
    window.stop();
    try {
        var localInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        if(localInterface){
            var strTemp = localInterface.excCommand(1203,szUrl);
            var bpPortal = localInterface.excCommand(1211,strTemp);
			
            XX_loadURL(bpPortal);
        //XX_loadURL(strTemp);
        }
    }catch (e){
    //dump(e);
    }
}

/*
function UpdateToolbarMenu()
{
  try {
		var localInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
		if(localInterface){
	   
			if(localInterface.excCommand(1205,null) == "0")
      {
        var strLabel = localInterface.excCommand(1103,255)
        document.getElementById('main-popup-minimize').setAttribute("label", strLabel);
      } 
      else
      {
        var strLabel = localInterface.excCommand(1103,245)
        document.getElementById('main-popup-minimize').setAttribute("label", strLabel);      
      } 
			
		}
	}catch (e){
		//dump(e);
	}
}*/

function DoTurnOnBP()
{
    try {
        var localInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        if(localInterface){
            localInterface.excCommand(1101,null);
            // refresh toolbar
            clearTimeout(timerBPOnOffId);
            XX_DoProcessRefreshConfig();
        }
    }catch (e){
    //dump(e);
    }
}

function DoSummaryPage()
{
    try {
        var localInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        if(localInterface){
            var url = parseUrl(window.content.document.location.href);
            if(/^(file\:\/\/\/)/.test(url) && /blocked.html/.test(url)){
                //if is in blocked page
                var asUrl = url.split('TOKEN=');
                if(asUrl.length > 0){
                    asUrl = asUrl[1].split('&REASON=');
                    if(asUrl.length > 0){
                        var sTempUrl = parseUrl(localInterface.excCommand(1203,asUrl[0]));
                        if(sTempUrl){
                            url = sTempUrl;
                        }
                    }
                }
            }
            var bpPortal = localInterface.excCommand(1211,url);			
            XX_loadURL(bpPortal);	
        }
    }catch (e){
    //dump(e);
    }
}

function DoMinimizeToolbar()
{
    try {
        var localInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        if(localInterface){
	   
            localInterface.excCommand(1206,null);
			
            // refresh toolbar
            clearTimeout(timerToolbarRefreshId);
            XX_DoProcessRefreshToolbar();
        }
    }catch (e){
    //dump(e);
    }
}

function XX_UpdateToolbarButton(szButton, szXXimg, szTooltips)
{
    var litmusObj = null;
    try {
        litmusObj = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
    }catch (e){
        dump(e);
    }
    
    if(litmusObj)
    {
      if(litmusObj.excCommand(1225, null) == 0) // orsp error
      {
        szButton = 'chrome://litmus-ff/skin/bp/lvl7.png';
      }
    }
    
    var nRateID = "";
    var btnLitmusFF = document.getElementById('litmus-ff-button');
    if(!btnLitmusFF){
        switch(szButton){
            case 'chrome://litmus-ff/skin/bp/lvl0.png':
                nRateID = "232";
                break;
            case "chrome://litmus-ff/skin/bp/lvl1.png":
            case "chrome://litmus-ff/skin/bp/lvl2.png":
                nRateID = "229";
                break;
            case "chrome://litmus-ff/skin/bp/lvl3.png":
            case "chrome://litmus-ff/skin/bp/lvl4.png":
                nRateID = "230";
                break;
            case "chrome://litmus-ff/skin/bp/lvl5.png":
                nRateID = "231";
                break;
            case "chrome://litmus-ff/skin/bp/lvl6.png":
                if(XX_GetPSC9_1_Pref() == "1")
                  nRateID = "272";
                else
                {
                  szButton = "chrome://litmus-ff/skin/bp/lvl1.png";
                  nRateID = "229";
                }
                break;
            case "chrome://litmus-ff/skin/bp/lvl7.png":
                nRateID = "278";
                break;                
            default:
                break;
        }
    } else
    if(btnLitmusFF){
        if(szButton == "chrome://litmus-ff/skin/bp/lvl0.png")
        {
            nRateID = "232";
            //document.getElementById('litmus-ff-button').removeAttribute("tooltiptext");
            //document.getElementById('litmus-ff-button').setAttribute("image", "chrome://litmus-ff/skin/bp/lvl1.png");
        }else if(szButton == "chrome://litmus-ff/skin/bp/lvl1.png" || szButton == "chrome://litmus-ff/skin/bp/lvl2.png")
        {
            nRateID = "229";
            //document.getElementById('litmus-ff-button').removeAttribute("tooltiptext");
            //document.getElementById('litmus-ff-button').setAttribute("image", "chrome://litmus-ff/skin/bp/lvl3.png");
        }else if(szButton == "chrome://litmus-ff/skin/bp/lvl3.png" || szButton == "chrome://litmus-ff/skin/bp/lvl4.png")
        {
            nRateID = "230";
            //document.getElementById('litmus-ff-button').removeAttribute("tooltiptext");
            //document.getElementById('litmus-ff-button').setAttribute("image", "chrome://litmus-ff/skin/bp/lvl5.png");
        }else if(szButton == "chrome://litmus-ff/skin/bp/lvl5.png")
        {
            nRateID = "231";
            //document.getElementById('litmus-ff-button').removeAttribute("tooltiptext");
            //document.getElementById('litmus-ff-button').setAttribute("image", "chrome://litmus-ff/skin/bp/lvl0.png");
        }else if(szButton == "chrome://litmus-ff/skin/bp/lvl6.png")
        {
            if(XX_GetPSC9_1_Pref() == "1")
            {
              nRateID = "272";
            }
            else
            {
              szButton = "chrome://litmus-ff/skin/bp/lvl1.png"
              nRateID = "229";
            }
            //document.getElementById('litmus-ff-button').setAttribute("tooltiptext", szTooltips);
            //document.getElementById('litmus-ff-button').setAttribute("image", "chrome://litmus-ff/skin/bp/lvl0.png");
        }else if(szButton == "chrome://litmus-ff/skin/bp/lvl7.png")
        {
          nRateID = "278";
        }
    }

    var eleLitmusFfButton = document.getElementById('litmus-ff-button');
    if(eleLitmusFfButton)
        eleLitmusFfButton.setAttribute("image", szButton.replace(/(big)/gi,"bp"));

    var eleXxImg = document.getElementById('xxImg');
    if(eleXxImg)
        eleXxImg.setAttribute("src", szXXimg);
    
    /*var eleLitmusFFTooltipText = document.getElementById('litmus-ff-tooltip-text');
    if(eleLitmusFFTooltipText)
        eleLitmusFFTooltipText.setAttribute("value", szTooltips);
    */
    // Rex: BP Gui integration

    var eleFsRatingButton = document.getElementById('FS-Rating-Button');
    if(eleFsRatingButton)
        eleFsRatingButton.setAttribute("image", szButton.replace(/(big)/gi,"bp"));
/*
    var litmusObj = null;
    try {
        litmusObj = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
    }catch (e){
        dump(e);
    }
*/
    if(litmusObj)
    {
        nRateID = nRateID;
        var strLabel = litmusObj.excCommand(1103, nRateID);
        if(litmusObj.excCommand(1205,null) != "0")
        {
            // do minimize
            strLabel = "";
        }

        if(eleFsRatingButton)
            eleFsRatingButton.setAttribute("label", unescape(strLabel) + "  ");
    }
}

function XX_StopBrowser(szResult, aRequest)
{
    var sCurrentUrl = parseUrl(window.content.document.location.href);
    var arParam = g_OnProgressResult.split("*");
  
    XX_UpdateToolbarButton(arParam[0].replace(/(small)/gi,"bp"), arParam[0].replace(/(small)/gi,"pop"), szResult);

    var szSite = "";
    var szAskSite = "";
    if(g_OnProgressRequest)
    {
        szSite = g_OnProgressRequest.name.split("://")[1]?g_OnProgressRequest.name.split("/")[2].split("?")[0]:g_OnProgressRequest.name.split("/")[0].split("?")[0];
        szAskSite = g_OnProgressRequest.name;
    }
    else
    {
        szSite = sCurrentUrl.split("://")[1]?sCurrentUrl.split("/")[2].split("?")[0]:sCurrentUrl.split("/")[0].split("?")[0];
        szAskSite = sCurrentUrl;
    }
  
    var litmusObj = null;
    try {
        litmusObj = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
    }catch (e){
    //dump(e);
    }
	
    if(szSite == "about:blank")
        return;
	   
    if(litmusObj != null){
	
      
        var bSkipAsk = litmusObj.excCommand(1111, szAskSite );
    	    	
        if(bSkipAsk != "1"){
            var answer = "";
            window.stop();
            answer = litmusObj.excCommand(1107, szSite + "*" + arParam[1]  + "*" + arParam[3]);
      
            //dump("skipping in ignore list" + bSkipAsk + "\n");
            if(answer == "cancel")
            {

                // Rex: BP Gui integration
                document.getElementById('FS-Rating-Button').setAttribute("image",arParam[0].replace(/(small)/gi,"bp"));

                document.getElementById('litmus-ff-button').setAttribute("image",arParam[0].replace(/(small)/gi,"bp"));
                if(g_OnProgressRequest) g_OnProgressRequest.cancel(0x804b0002);
      		
                setTimeout(XX_StopBrowserEx,1, szAskSite);
            //XX_loadURL(XX_GetBlockUrl());
            }else if(answer == "continue")
            {
                XX_loadURL(szAskSite);
            }
        }
  
    }
	
}


function XX_RefreshToolbarIcon()
{
    var sCurrentUrl = parseUrl(window.content.document.location.href);
    if(pluginInterface == null)
    {
        try {
            pluginInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        }catch (e){
        //dump(e);
        }
    }
    if(XX_GetUserPref() == "0" ||
        sCurrentUrl.indexOf("http://localhost/")==0 || sCurrentUrl.indexOf("chrome://")==0 || sCurrentUrl.indexOf("about:")==0 || sCurrentUrl.indexOf("file://")==0
        ) {
        /*if(XX_GetUserPref() != "0")
        {
            try{
            document.getElementById('litmus-ff-button').setAttribute("image","chrome://litmus-ff/skin/bp/on.png");
            document.getElementById('litmus-ff-tooltip-text').setAttribute("value","");
            }catch(e){}
        }	*/
        return;
    }
    var strBlockPage = XX_GetBlockUrlEx();
    if(sCurrentUrl.indexOf(strBlockPage)==0)
    {
        var menuCheck = document.getElementById('InstantWhite');
        //turn off menu item
        if( menuCheck )
        {
            menuCheck.setAttribute("disabled","true");
        }
        /*if(XX_GetUserPref() != "0")
        {
            document.getElementById('litmus-ff-button').setAttribute("image","chrome://litmus-ff/skin/bp/on.png");
            document.getElementById('litmus-ff-tooltip-text').setAttribute("value","");
            return;
        }*/
    }
    var szHref = sCurrentUrl;
    if (szHref.match(/^http:\/\/rds.yahoo.com/))
    {
        szHref = szHref.split("/**")[1];
    }

    var szResult = pluginInterface.getSiteRate(szHref,1);
    var szSite = "";
    szSite = szHref.split("://")[1]?szHref.split("/")[2].split("?")[0]:szHref.split("/")[0].split("?")[0];
    if( szResult != "" )
    {
        try{
        document.getElementById('litmus-ff-tooltip-docloc').setAttribute("value",szHref);
        var arParam = szResult.split("*");
        //check is request address same as toolbat address
        document.getElementById('litmus-ff-button').setAttribute("image",arParam[0].replace(/(small)/gi,"bp"));
        document.getElementById("xxImg").setAttribute("src",arParam[0].replace(/(small)/gi,"pop"));
        //document.getElementById('litmus-ff-tooltip-text').setAttribute("value",szResult);
        }catch(e){}
        // Rex: BP Gui integration
        try{
        document.getElementById('FS-Rating-Button').setAttribute("image",arParam[0].replace(/(small)/gi,"bp"));
        }catch(e){}

  		
    } /*else {
        try{
        document.getElementById('litmus-ff-button').setAttribute("image","chrome://litmus-ff/skin/bp/on.png");
        document.getElementById('litmus-ff-tooltip-text').setAttribute("value",szResult);
        }catch(e){}
    }*/
}


function XX_Submit(URL)
{
    //	dump("site is submitting.....*" + event.target + "*..\n");
    var szSiteName = URL;
    //	dump("address is recv.....*" + szSiteName + "*..\n");
    //	if(event.cancelable)
    //		event.preventDefault();
    if(pluginInterface == null)
    {
        try {
            pluginInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        }catch (e){
        //dump(e);
        }
    }
	
    if(XX_GetUserPref() == "0" ||
        URL.indexOf("http://localhost/")==0 || URL.indexOf("chrome://")==0 || URL.indexOf("about:")==0 || URL.indexOf("file://")==0
        ) {
        //if(XX_GetUserPref() == "3" || event.target.action.indexOf("chrome://")==0 || event.target.action.indexOf("file://")==0
        //) {
        return;
    }
    //	var szDomain = event.target.action.split("://")[1]?event.target.action.split("/")[2].split("?")[0]:event.target.action.split("/")[0].split("?")[0];
    var szDomain = szSiteName.split("?")[1]? szSiteName.split("?")[0]:szSiteName;
    //	dump("site is submitting.....*" + szDomain + "*..\n");
    var szResult = pluginInterface.getSiteRate(szDomain,4);
	
    //	dump("Site result = ## " + szResult + " ##\n");
    if( szResult != "" )
    {
        var arParam = szResult.split("*");
	
        ///*
        if(arParam[3])
        {

      
            var szSite = szSiteName.split("://")[1]?szSiteName.split("/")[2].split("?")[0]:szSiteName.split("/")[0].split("?")[0];
            if(parseInt(arParam[3]) == 1 && XX_GetUserOption(1)&8)
            {
                setTimeout(XX_StopBrowserEx,1, szSiteName);
                //if(event.cancelable) event.preventDefault();
                XX_loadURL(XX_GetBlockUrl(szSiteName));
            }
			
            if(parseInt(arParam[3]) == 1 && XX_GetUserOption(1)&16)
            {
	
                var answer = pluginInterface.excCommand(1108, szSite + "*" + arParam[1]  + "*" + arParam[3]);
                if(answer == "cancel")
                {
                    setTimeout(XX_StopBrowserEx,1, szSiteName);
                    //if(event.cancelable) event.preventDefault();
                    XX_loadURL(XX_GetBlockUrl(szSiteName));
                }
            }
            if(parseInt(arParam[3]) == 2 && XX_GetUserOption(1)&8)
            {
                setTimeout(XX_StopBrowserEx,1,szSiteName);
                //if(event.cancelable) event.preventDefault();
                XX_loadURL(XX_GetBlockUrl(szSiteName));
            }
		
    
            if(parseInt(arParam[3]) == 2 && XX_GetUserOption(1)&16)
            {
	
                var answer = pluginInterface.excCommand(1108, szSite + "*" + arParam[1]  + "*" + arParam[3]);
                if(answer == "cancel")
                {
                    setTimeout(XX_StopBrowserEx,1, szSiteName);
                    //if(event.cancelable) event.preventDefault();
                    XX_loadURL(XX_GetBlockUrl(szSiteName));
                }
            }
			
            if(parseInt(arParam[3]) == 3 && XX_GetUserOption(2)&8)
            {
                setTimeout(XX_StopBrowserEx,1,szSiteName);
                //if(event.cancelable) event.preventDefault();
                XX_loadURL(XX_GetBlockUrl(szSiteName));
            }
            if(parseInt(arParam[3]) == 3 && XX_GetUserOption(2)&16)
            {
	
                var answer = pluginInterface.excCommand(1108, szSite + "*" + arParam[1]  + "*" + arParam[3]);
                if(answer == "cancel")
                {
                    setTimeout(XX_StopBrowserEx,1, szSiteName);
                    //if(event.cancelable) event.preventDefault();
                    XX_loadURL(XX_GetBlockUrl(szSiteName));
                }
            }
			
            if(parseInt(arParam[3]) == 0 && XX_GetUserOption(3)&8 )
            {
			
                setTimeout(XX_StopBrowserEx,1, szSiteName);
                //if(event.cancelable) event.preventDefault();
                XX_loadURL(XX_GetBlockUrl(szSiteName));
            }
			
            if(parseInt(arParam[3]) == 0 && XX_GetUserOption(3)&16)
            {
	
                var answer = pluginInterface.excCommand(1108, szSite + "*" + arParam[1]  + "*" + arParam[3]);
                if(answer == "cancel")
                {
                    setTimeout(XX_StopBrowserEx,1, szSiteName);
                    //if(event.cancelable) event.preventDefault();
                    XX_loadURL(XX_GetBlockUrl(szSiteName));
                }
            }
        }
    }
}

function OnSwitchToProfile(profileId)
{
    if(pluginInterface == null)
    {
        try {
            pluginInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        }catch (e){
        //dump(e);
        }
    }
    
    if(pluginInterface)
    {
        pluginInterface.excCommand(1215, profileId);
    }
}

function DoTurnOnFSPC()
{
    try {
        var localInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        if(localInterface){
            localInterface.excCommand(1218,null);
            // refresh toolbar
            //clearTimeout(timerBPOnOffId);
            //XX_DoProcessRefreshConfig();
        }
    }catch (e){
    //dump(e);
    }
}

var gToolbarDropObserver = null;
var gPaletteWinDropObserver = null;
var nPaletteIntervalId = null;
var szFSMMenu = FS_getLabelById("Browsing protection");
var szFSNotify = FS_getLabelById("Notify us");
var szFSRating = FS_getLabelById("Safety rating") + "  ";
var szFSParental = FS_getLabelById("Parental Control");
var gToolbox = null;
var isFirefox35 = /Firefox[\/\s](3\.5)/.test(navigator.userAgent);

function FS_CustomizeToolbarClosed(){
    clearInterval(nPaletteIntervalId);
    //unload - remove all event listeners
    try{
        //ff2, 3.5
        onUnload();
    }
    catch(e){
        //ff3
        finishToolbarCustomization();
    }
    if(gToolbox){
        try{
            gToolbox.removeEventListener("drop", gToolbarDropObserver, false);
        }catch(e){}
        try{
            gToolbox.removeEventListener("dragdrop", gToolbarDropObserver, false);
        }catch(e){}
    }
}

function FS_paletteWindowObserver(aEvent){
    var paletteItem = gToolbox.palette.firstChild;
    while(paletteItem){
        if(paletteItem.id == "FS-MainMenu" || paletteItem.id == "wrapper-FS-MainMenu")
        {
            if(paletteItem.getAttribute("label") != szFSMMenu)
            {
                paletteItem.setAttribute("label", szFSMMenu);
                if(isFirefox35){
                    buildPalette();
                }
            }
        }
        if(paletteItem.id == "FS-Report-Button" || paletteItem.id == "wrapper-FS-Report-Button")
        {
            if(paletteItem.getAttribute("label") != szFSNotify)
            {
                paletteItem.setAttribute("label", szFSNotify);
                if(isFirefox35){
                    buildPalette();
                }
            }
        }
        if(paletteItem.id == "FS-Rating-Button" || paletteItem.id == "wrapper-FS-Rating-Button")
        {
            if(paletteItem.getAttribute("label") != szFSRating)
            {
                paletteItem.setAttribute("label", szFSRating);
                if(isFirefox35){
                    buildPalette();
                }
            }
        }
        if(g_OnFspcLoaded && XX_GetPSC9_1_Pref() == "1")
        {
          if(paletteItem.id == "FS-Parental-Button" || paletteItem.id == "wrapper-FS-Parental-Button")
          {
              if(paletteItem.getAttribute("label") != szFSParental)
              {
                  paletteItem.setAttribute("label", szFSParental);
                  if(isFirefox35){
                      buildPalette();
                  }
              }
          }
        }        
        paletteItem = paletteItem.nextSibling;
    }
    try{
        OnRefreshToolbar();
    }catch(e){}
}

var oriRestoreDefaultSet;
function newRestoreDefaultSet()
{
    var litmusObj = null;
    try {
        litmusObj = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
    }catch (e){
        dump(e);
    }
	
    if(litmusObj)
    {
        
        if(litmusObj.excCommand(1205,null) != "0")
        {
            // restore to default maximize toolbar
            DoMinimizeToolbar();
        }
    }

    oriRestoreDefaultSet();
}

function FS_CustomizeToolbarOpened()
{
    oriRestoreDefaultSet = restoreDefaultSet;
    restoreDefaultSet = newRestoreDefaultSet;
    //add event listener for customizable toolbar window
    var objToolbox = null;
    if ("arguments" in window && window.arguments[0]) {
        objToolbox = window.arguments[0];
    }
    else if (window.frameElement &&
        "toolbox" in window.frameElement) {
        objToolbox = window.frameElement.toolbox;
    }
    var toolbarDropObserver = function(e){
        //not show label for main menu button when dragged to toolbar
        node = objToolbox.palette.firstChild;
        while(node){
            if(node.id == 'FS-MainMenu')
            {
                node.setAttribute("label", "");
                break;
            }
            node = node.nextSibling;
        }
    };


    if(objToolbox){
        //assigned to global variable
        gToolbox = objToolbox;
        gToolbarDropObserver = toolbarDropObserver;
        //ff3.5
        try{
            objToolbox.addEventListener("drop", toolbarDropObserver, false);
        }catch(e){}
        //ff2,3
        try{
            objToolbox.addEventListener("dragdrop", toolbarDropObserver, false);
        }catch(e){}
        
        //add label for icon before customize toolbar window loaded
        var itemNode = objToolbox.palette.firstChild;
        var bTurnedOn = XX_GetUserPref() == 0;
        while(itemNode){
            if(itemNode.id == 'FS-MainMenu'){
                itemNode.setAttribute("label", szFSMMenu);
            }
            if(itemNode.id == 'FS-Rating-Button'){
                itemNode.setAttribute("label", szFSRating);
                if(bTurnedOn){
                    try{
                        itemNode.setAttribute("hidden","true");
                    }catch(e){}
                }
            }
            if(itemNode.id == 'FS-Report-Button'){
                itemNode.setAttribute("label", szFSNotify);
                if(bTurnedOn){
                    try{
                        itemNode.setAttribute("hidden","true");
                    }catch(e){}
                }
            }
            if(g_OnFspcLoaded && XX_GetPSC9_1_Pref() == "1")
            {
              if(itemNode.id == 'FS-Parental-Button'){
                  itemNode.setAttribute("label", szFSParental);
                  if(bTurnedOn){
                      try{
                          itemNode.setAttribute("hidden","true");
                      }catch(e){}
                  }
              }
            }            
            itemNode = itemNode.nextSibling;
        }
    }
    
    //show correct icon in customize toolbar window
    onLoad();
    FS_paletteWindowObserver();
    nPaletteIntervalId = setInterval(FS_paletteWindowObserver, 1000);
    var paletteItem = gToolbox.palette.firstChild;
    while(paletteItem.id != "FS-MainMenu")
    {
        paletteItem = paletteItem.nextSibling;
        if(!paletteItem){
            return;
        }
    }
    if(paletteItem.id == "FS-MainMenu"){
        //the icon is inside toolbar palette
        var pluginInterface = null;
        var fsIcon = "";
        try{
            pluginInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
        }catch(e){

        }
        if(pluginInterface){
            fsIcon = pluginInterface.excCommand(1210,null);
        }
        if(fsIcon!=""){
            paletteItem.setAttribute("image", unescape(fsIcon));
        }else
        {
            paletteItem.setAttribute("image", "chrome://litmus-ff/skin/bp/fsecure.png");
        }
    }
}

function debug(output, level, application){
    output = output || "";
    output = "<" + getFuncName(arguments.callee.caller) + ">" + (output ? " : " + output : "");
    level = level || 3;
    application = application || "default";
    var logMngr = Components.classes["@mozmonkey.com/debuglogger/manager;1"] .getService(Components.interfaces.nsIDebugLoggerManager);
    if(!logMngr){
        dump(output);
        return;
    }
    var logger = logMngr.registerLogger(application);
    logger.log(level, output);

    function getFuncName(func){
        func = func.toString().substr('function '.length);
        func = func.substr(0, func.indexOf('('));
        return func;
    }
}

function FS_hideToolbar()
{
    try{
        document.getElementById('FS-Toolbar').collapsed = !document.getElementById('FS-Toolbar').collapsed;
    }catch(e){

    }
}

function FS_getLabelById(nId)
{
    if(typeof nId == 'string'){
        return nId;
    }

    var localInterface = Components.classes["@f-secure.com/litmus-ff/litmus-ff;1"].getService(Components.interfaces.ILitmusFF);
    if(localInterface){
        return localInterface.excCommand(1103, nId);
    }else{
        return "";
    }
}

function parseUrl(sUrl, bWorkAround){
    sUrl = sUrl.toString();
    bWorkAround = bWorkAround || false;
    
    if(/^(chrome\:\/\/)/.test(sUrl)){
        //not support chrome protocol
        sUrl = bWorkAround ? 'mailto:' : '';
    }
    
    if(/^(about\:)/.test(sUrl)){
        //match about:blank, about:config, etc
        sUrl = bWorkAround ? 'mailto:' : '';
    }
    return sUrl;
}
